package org.act.metaset;
import java.io.InputStream;
import java.util.ArrayList;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class MetasetParser {
	
	public Metaset parse(InputStream in) {
		ServiceSetContentHandler handler = new ServiceSetContentHandler();
		SAXParserFactory factory = SAXParserFactory.newInstance();
		try {
			SAXParser saxParser = factory.newSAXParser();
			saxParser.parse(in, handler);
					} catch (Exception ex) {
			ex.printStackTrace();
			return null;
		}
		return handler.getResult();
	}
	private static MetasetParser instance;
	public static MetasetParser getInstance() {
		if (instance == null) {
			instance = new MetasetParser();
		}
		return instance;
	}
}
      
class ServiceSetContentHandler extends DefaultHandler {
	private ArrayList stack = new ArrayList();
	private Metaset result = null;
	private boolean isEndElement = true;
	
	public void startElement(
		String namespaceURI,
		String localName,
		String qName,
		Attributes atts)
		throws SAXException {
		QName qname = new QName(qName);
		Metaset tmp =
			new Metaset(qname.getNameSpace(), qname.getName());
		for (int i = 0; i < atts.getLength(); i++) {
			Attribute param =
				new Attribute(new QName(atts.getQName(i)), atts.getValue(i));
			tmp.add(param);
		}
		if (stack.size() != 0) {
			Metaset father = (Metaset) stack.get(stack.size() - 1);
			father.add(tmp);
			tmp.setFather(father);
		} else {
			result = tmp;
		}
		stack.add(tmp);
	}
	
	public void endElement(String namespaceURI, String localName, String qName)
		throws SAXException {
		stack.remove(stack.size() - 1);
		isEndElement = true;
	}
	
	public void characters(char[] ch, int start, int length)
		throws SAXException {
		isEndElement = false;
		String str = new String(ch, start, length);
		if (!str.trim().equals("")) {
			Metaset tmp = (Metaset) stack.get(stack.size() - 1);
			if (!isEndElement) {
				if (tmp.getValue()!=null) {
					tmp.setValue(tmp.getValue() + str);
				}
				else {
					tmp.setValue(str);
				}
			}
		}
	}
	
	public Metaset getResult() {
		return result;
	}
	
	public void processingInstruction(String target,String data) {
		System.err.println(target+":"+data);
	}
}
