package org.act.metaset;

public class QName {
	private String name = null;
	private String namespace = "";
	
	public QName(String qName) {
		int pos = qName.indexOf(":");
		if (pos >= 0) {
			namespace = qName.substring(0, pos);
			name = qName.substring(pos + 1);
		} else {
			name = qName;
		}
	}
	
	public QName(String namespace, String name) {
		if (namespace==null || name==null) {
			throw new IllegalArgumentException();
		}
		this.namespace = namespace;
		this.name = name;
	}
	
	public String getName() {
		return name;
	}
	
	public String getNameSpace() {
		return namespace;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public void setNameSpace(String namespace) {
		this.namespace = namespace;
	}
	
	
	public boolean equals(Object obj) {
		if (obj==this) {
			return true;
		}
		if (!(obj instanceof QName)) {
			return false;
		}
		QName qName = (QName) obj;
		boolean result = true;
		if (namespace!=null) {
			result = namespace.equals(qName.namespace);
		}
		if (name!=null) {
			result = name.equals(qName.name);
		}
				return result;	}
	
	
	public int hashCode() {
		return namespace.hashCode() + name.hashCode();
	}
	public String toString() {
    if (namespace!=null && !namespace.equals("")) {
			return namespace + ":" + name;
		} else {
			return name;
		}
	}
}
