
package org.act.services.connector;
import java.util.ArrayList;
import java.util.List;
import org.act.metaset.Metaset;
import org.act.services.ConfigException;
import org.act.services.runtime.IRuntime;
import org.act.services.runtime.lifecycle.ALifecycle;

public abstract class AObjectPoolConnector extends ALifecycle implements IObjectPoolConnector {
	
	private String name;
	private String description;
	private List protocols;
	protected IRuntime runtime;
	
	public AObjectPoolConnector(IRuntime runtime) {
		this.runtime = runtime;
	}
	
	
	public String getName() {
		return name;
	}
	
	public String getDescription() {
		return description;
	}
	
	public void config(Metaset conf) throws ConfigException {
		name = conf.selector(".\\","name");
		if (name==null) 
			throw new IllegalArgumentException();
		description = conf.selector(".\\","description");
	}
	
	public List getProtocols() {
		if (protocols==null) {
			protocols = new ArrayList(5);
		}
		return protocols;
	}
}
