
package org.act.services.pool;
import java.util.ArrayList;
import java.util.List;

public final class ObjectPool implements IObjectPool {
	
	private List list = new ArrayList();
	
	public synchronized Object get() {
		while(empty()) {
			try {
				this.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		Object obj= list.get(list.size()-1);		list.remove(list.size()-1);
				return obj;
	}
	
	public synchronized void put(Object obj) {
		while (full()) {
			try {
				this.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		list.add(obj);
							}
	
	
	public synchronized boolean empty() {
		return list.size()==0;	}
	
	public synchronized boolean full() {
		if (list.size()==maxSize) {
			return true;
		}
				return false;
	}
	
	public synchronized int size() {
		return list.size();
	}
	
	public Object get(int i) {
				return list.get(i);
	}
	
	public boolean remove(int i) {
		list.remove(i);
		return true;
	}
	
	private int maxSize = 13;
	
	
	public void setMaxSize(int size) {
		this.maxSize = size;
	}
	public int getMaxSize() {
		return this.maxSize;
	}
}
