
package org.act.services;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.metaset.QName;
import org.act.services.pool.IObjectPool;
import org.act.services.protocol.http.HTTPReplyTransportContext;
import org.act.services.runtime.IRuntime;

public class ClientOUTMessageContext extends MessageContext {
		private String operationName = null;
		private String url = null;
		private IRuntime runtime;
	
	public ClientOUTMessageContext(Metaset content,String url,IRuntime runtime){	   
		this.runtime = runtime;
		this.url = url;		
		try {
			
			this.setResponseServices(content);
			IObjectPool pool = runtime.getObjectPool("transport",IObjectPool.IN_MODE);
			this.setResponseTransportContext(new HTTPReplyTransportContext(url, pool));
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
		}
		  
	
		public ClientOUTMessageContext(String operationName, String url, IRuntime runtime) {
	this.operationName = operationName;
	this.runtime = runtime;
	this.url = url;		
	try {
		Metaset request = new Metaset("soapenv","Envelope");
		request.add(new Attribute(new QName("soapenv","encodingStyle"),"http://schemas.xmlsoap.org/soap/encoding/"));
		request.add(new Attribute(new QName("xmlns","soapenv"),"http://schemas.xmlsoap.org/soap/envelope/"));
		request.add(new Attribute(new QName("xmlns","xsi"),"http://www.w3.org/2001/XMLSchema-instance"));
		request.add(new Attribute(new QName("xmlns","xsd"),"http://www.w3.org/2001/XMLSchema"));
				request.add(new Attribute(new QName("xmlns","soapenc"),"http://schemas.xmlsoap.org/soap/encoding/"));
				Metaset header = new Metaset("soapenv","Header");
		request.add(header);
		Metaset body = new Metaset("soapenv","Body");		
		Metaset operation = new Metaset(operationName);
		Metaset parameter = new Metaset("param0");
		parameter.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
		parameter.setValue("zhuyan");
		operation.add(parameter);
		body.add(operation);
		request.add(body);
		this.setResponseServices(request);
		IObjectPool pool = runtime.getObjectPool("transport",IObjectPool.IN_MODE);
		this.setResponseTransportContext(new HTTPReplyTransportContext(url, pool));
	}
	catch (Exception ex) {
		ex.printStackTrace();
	}
	}
	
	}
