package org.act.services;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.metaset.QName;
import org.act.services.pool.IObjectPool;
import org.act.services.protocol.http.HTTPReplyTransportContext;
import org.act.services.runtime.IRuntime;

public class ReplyMessageContext extends MessageContext {
	
	private String operationName = null;
	private Metaset params = null;
	private Metaset correlationSets = null;
	private String url = null;
	private IRuntime runtime;
	
	
	
	public ReplyMessageContext(String operationName,Metaset params,Metaset correlationSets,String url, IRuntime runtime,Metaset tranContextServicesSet) {
		this.operationName = operationName;
		this.params = params;
		this.correlationSets = correlationSets;
		this.runtime = runtime;
		this.url = url;		
		try {
			Metaset response = new Metaset("soapenv","Envelope");
			response.add(new Attribute(new QName("soapenv","encodingStyle"),"http://schemas.xmlsoap.org/soap/encoding/"));
			response.add(new Attribute(new QName("xmlns","soapenv"),"http://schemas.xmlsoap.org/soap/envelope/"));
			response.add(new Attribute(new QName("xmlns","xsi"),"http://www.w3.org/2001/XMLSchema-instance"));
			response.add(new Attribute(new QName("xmlns","xsd"),"http://www.w3.org/2001/XMLSchema"));
			response.add(new Attribute(new QName("xmlns","soapenc"),"http://schemas.xmlsoap.org/soap/encoding/"));			
						Metaset header = new Metaset("soapenv","Header");
						if(correlationSets != null)
				header.add(correlationSets);
						if(!tranContextServicesSet.isEmpty())
				header.add(tranContextServicesSet);
			
			response.add(header);
			
			Metaset body = new Metaset("soapenv","Body");
			
			Metaset res = new Metaset(operationName);
			
			for (int i=0; i<params.getChilds().size(); i++) {
				Metaset item = (Metaset)params.getChilds().get(i);
								String value = item.getValue();
								String typeValue = item.selector(".\\","type");
				
								Metaset part = new Metaset(item.selector(".\\","name")); 
				
								part.setValue(value);
				
								part.add(new Attribute("xsi:type",typeValue));
				
			    res.add(part);			}
			
			body.add(res);
			response.add(body);
			
						
			this.setResponseServices(response);
			IObjectPool pool = runtime.getObjectPool("transport",IObjectPool.IN_MODE);
			this.setResponseTransportContext(new HTTPReplyTransportContext(url, pool));
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
		
	}
}
