
package org.act.services.wsrm;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Timer;
import org.act.message.timer.GroupExpiryTimerTask;
import org.act.message.timer.GroupReSendTask;

public class Group implements IGroup {
		ArrayList AL;
		public final int Running   = 0;
	public final int Completed = 1;
	public final int Closed    = 2;
	public final int Removed   = 3;
	private int state = Running;
	
		private ReliableMessage lastRM;
	
	
	
		private String groupId;
		private Date groupExpiryTime;
		private int groupMaxIdleDuration;
		private long startTime;
	
	
	
	
	
		private boolean GuaranteedDelivery;
		private boolean NoDuplicateDelivery;
		private boolean ExactOnceDelivery;
		private boolean OrderedDelivery;
	
		public final int ReceivingRMP = 0;
	public final int SendingRMP   = 1;
	
	
	public Timer myExpTimer = null;
	public GroupExpiryTimerTask gExpTask = null;
	public Timer myReSendTimer = null;
	public GroupReSendTask gReSendTask = null;
		
	
	public Group() {
	super();
		init();
	}
	
	public void init() {
	initGroupState();
	initGroupParameters();
	initRMAgreements();
	}
	
	public void initGroupState() {
	this.state = Running;
	this.lastRM = null;
	}
	
	public void initGroupParameters() {
	this.AL = new ArrayList();
	this.groupId = "";
	this.groupExpiryTime = null;
	this.groupMaxIdleDuration = -1;
	this.startTime = System.currentTimeMillis();
	}
	
	
	public void initRMAgreements() {
	this.GuaranteedDelivery = false;
	this.NoDuplicateDelivery = false;
	this.ExactOnceDelivery = false;
	this.OrderedDelivery = false;
	}
	
		
	public String addMessage(ReliableMessage rm) {
	String result = "Right";
	if ( rm.whetherIsLast() ) {			result = addMessageWhenIsLastRm(rm, result);
	}
	else {			result = addMessageWhenIsNotLastRm(rm, result);
	}
	return result;
	}
	
	public String addMessageWhenIsLastRm(ReliableMessage rm, String result) {
	if ( this.lastRM == null ) {			rm.setState(rm.UndeliveredWait);
		this.lastRM = new ReliableMessage();
		this.lastRM = rm;
		this.AL.add(rm);
	} else {
				result = "Error Group.addMessage(): lastRM exists";
	}
	return result;
	}
	
	public String addMessageWhenIsNotLastRm(ReliableMessage rm, String result) {
	int index = isDuplicated(rm);
	if ( -1 != index ) {			if ( this.GuaranteedDelivery && !this.NoDuplicateDelivery ) {				
			ReliableMessage temp = (ReliableMessage)this.AL.get(index);
			temp.setState(rm.UndeliveredWait);
		} else if ( !this.GuaranteedDelivery && this.NoDuplicateDelivery ) { 						result = "SendRMReplyCache";
		} else { 						result = "PermanentProcessingFailure: Exactly Once or Message Order " +
					"and RM can not be delivered again"; 
		}
	} else { 		rm.setState(rm.UndeliveredWait);
		this.AL.add(rm);
	}
	return result;
	}
	
	
	public void addMessageByIndex(ReliableMessage rm, int index) {
	this.AL.add(index, rm);
	}
	
	
	public ReliableMessage getMessage(int index) {
	return (ReliableMessage) AL.get(index);
	}
	
	public void removeMessage(int index) {
	this.AL.remove(index);
	}
	
	
	public boolean IfGroupEmpty() {
	if ( this.AL.isEmpty() == true ) {
		return true;
	} else {
		return false;
	}
	}
	
	
	public int getSize() {
	return this.AL.size();
	}
	
	
	public void clear() {
	AL.clear();
	}
	
	
	public ArrayList getArraylist(){
	return AL;
	}
	
	
	public void setArrayList(ArrayList AL){
	this.AL = AL;
	}
	
	
	public int getState() {
	return state;
	}
	
	
	public void setState(int state){
	this.state = state;
	}
	
	
	public ReliableMessage getlastRM() {
	return lastRM;
	}
	
	
	public void setLastRM(ReliableMessage last) {
	this.lastRM = last;
	}
	
	
	public String getGroupId() {
	return groupId;
	}
	
	
	public void setGroupId(String sID) {
	this.groupId = sID;
	}
	
	
	public void setGroupId(ReliableMessage rm) {
	this.groupId = rm.getGroupId();
	}
	
	
	public Date getGroupExpiryTime() {
	return groupExpiryTime;
	}
	
	
	public void updateGroupExpiryTime(Date update) {
	this.groupExpiryTime = update;
	}
	
	
	public void setGroupExpiryTime(ReliableMessage rm) {
	String s = null;
	if (rm.getIMessageContext().getRequestServices() != null) {
		s = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header\\" +
			"Request\\MessageId\\SequenceNum", "groupExpiryTime");
	} else {
		s = rm.getIMessageContext().getResponseServices().selector("Envelope\\Header\\" +
			"Request\\MessageId\\SequenceNum", "groupExpiryTime");
	}
	if (s != null) {
		SimpleDateFormat SDF = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss-HH:mm");
		
	    try {
	    	this.groupExpiryTime = SDF.parse(s);
	    	if (WSRMUtil.SupportTimerTask) {
		    	try {
			    				    				    	myExpTimer = new Timer();
					gExpTask = new GroupExpiryTimerTask(groupId);
					myExpTimer.schedule(gExpTask, this.groupExpiryTime);
		    	} catch (IllegalArgumentException arg) {
		    		arg.printStackTrace();
		    	} catch (IllegalStateException state) {
		    		state.printStackTrace();
		    	}
						    			    		    	}
	    }
	    catch (ParseException ex) {
	    	ex.printStackTrace();
	    	System.out.println("Group.setGroupExpiryTime(): error occurs when type casting");
	    }
	}
	}
	
	
	public long getGroupMaxRmExpiryTime() {
	long result = 0L;
	ReliableMessage rm = null;
		for ( int i = 0; i < this.getSize() ; i ++ ) {
		rm = (ReliableMessage)this.AL.get(i);
		if ( rm.getExpiryTime().getTime() > result ) {
			result = rm.getExpiryTime().getTime();
					}
	}
	return result;
	}
	
	
	public int getGroupMaxIdleDuration() {
	return groupMaxIdleDuration;
	}
	
	
	public void setGroupMaxIdleDuration(int duration) {
	this.groupMaxIdleDuration = duration;
	}
	
	
	public void setGroupMaxIdleDuration(ReliableMessage rm) {
	String s = null;
	if (rm.getIMessageContext().getRequestServices() != null) {
		s = rm.getIMessageContext().getRequestServices().
			selector("Envelope\\Header\\" +
			"Request\\MessageId\\SequenceNum", "groupMaxIdleDuration");
	} else {
		s = rm.getIMessageContext().getResponseServices().
			selector("Envelope\\Header\\" +
			"Request\\MessageId\\SequenceNum", "groupMaxIdleDuration");
	}
	if ( s != null ) {
		this.groupMaxIdleDuration = Integer.parseInt(s);
	}
	}
	
	
	public long getStartTime() {
	return startTime;
	}
	
	
	public void setStartTime(long time) {
	this.startTime = time;
	}
	
	
	
	
	public boolean getGuaranteedDelivery() {
	return this.GuaranteedDelivery;
	}
	
	
	public void setGuaranteedDelivery(boolean bGuaranteedDelivery) {
	this.GuaranteedDelivery = bGuaranteedDelivery;
	}
	
	
	public void setGuaranteedDelivery(ReliableMessage rm) {
	String s = null;
	if (rm.getIMessageContext().getRequestServices() != null) {
		s = rm.getIMessageContext().getRequestServices().
			selector("Envelope\\Header\\Request\\AckRequested");
	} else {
		s = rm.getIMessageContext().getResponseServices().
			selector("Envelope\\Header\\Request\\AckRequested");
	}
	if ( "AckRequested".equals(s) ) {
		this.GuaranteedDelivery = true;
	}
	else {
		this.GuaranteedDelivery = false;
	}
	}
	
	
	public boolean getNoDuplicateDelivery() {
	return this.NoDuplicateDelivery;
	}
	
	
	public void setNoDuplicateDelivery(boolean bNoDuplicateDelivery) {
	this.NoDuplicateDelivery = bNoDuplicateDelivery;
	}
	
	
	public void setNoDuplicateDelivery(ReliableMessage rm) {
	String s = null;
	if (rm.getIMessageContext().getRequestServices() != null) {
		s = rm.getIMessageContext().getRequestServices().
				selector("Envelope\\Header\\Request" +
				"\\DuplicateElimination");
	} else {
		s = rm.getIMessageContext().getResponseServices().
				selector("Envelope\\Header\\Request" +
				"\\DuplicateElimination");
	}
	if ( "DuplicateElimination".equals(s) ) {
		this.NoDuplicateDelivery = true;
	}
	else {
		this.NoDuplicateDelivery = false;
	}
	}
	
	
	public boolean getExactOnceDelivery() {
	return this.ExactOnceDelivery;
	}
	
	
	public void setExactOnceDelivery(boolean bExactOnceDelivery) {
	this.ExactOnceDelivery = bExactOnceDelivery;
	}
	
	
	public void setExactOnceDelivery(ReliableMessage rm) {	
	String sa = null, sd = null;
	if (rm.getIMessageContext().getRequestServices() != null) {
		sa = rm.getIMessageContext().getRequestServices().
				selector("Envelope\\Header\\" +
				"Request\\AckRequested");
		sd = rm.getIMessageContext().getRequestServices().
				selector("Envelope\\Header\\" +
				"Request\\DuplicateElimination");
	} else {
		sa = rm.getIMessageContext().getResponseServices().
				selector("Envelope\\Header\\" +
				"Request\\AckRequested");
		sd = rm.getIMessageContext().getResponseServices().
				selector("Envelope\\Header\\" +
				"Request\\DuplicateElimination");
	}
	if ( ( "DuplicateElimination".equals(sd) ) && ( "AckRequested".equals(sa) ) ) {
		this.ExactOnceDelivery = true;
	}
	else {
		this.ExactOnceDelivery = false;
	}
	}
	
	
	public boolean getOrderedDelivery() {
	return this.OrderedDelivery;
	}
	
	
	public void setOrderedDelivery(boolean bOrderedDelivery) {
	this.OrderedDelivery = bOrderedDelivery;
	}
	
	
	public void setOrderedDelivery(ReliableMessage rm) {
	String s = null;
	if (rm.getIMessageContext().getRequestServices() != null) {
		s = rm.getIMessageContext().getRequestServices().
			selector("Envelope\\Header\\Request\\MessageOrder");
	} else {
		s = rm.getIMessageContext().getResponseServices().
			selector("Envelope\\Header\\Request\\MessageOrder");
	}
	if ( "MessageOrder".equals(s) ) {
		this.OrderedDelivery = true;
	}
	else {
		this.OrderedDelivery = false;
	}
	}
	
	
	public void setAll(ReliableMessage rm) {			setGroupId(rm);
	setGroupExpiryTime(rm);
	setGroupMaxIdleDuration(rm);
	setGuaranteedDelivery(rm);
	setNoDuplicateDelivery(rm);
	setExactOnceDelivery(rm);
	setOrderedDelivery(rm);
		}
	
	
	public String rmMatchGroup(ReliableMessage rm) {
	String result = "Right";
	 
	result = rmMatchGroupTestGroupId(rm, result);
	if ( "Right".equals(result) ) {
		result = rmMatchGroupTestAckRequested(rm, result);
		if ( "Right".equals(result) ) {
			result = rmMatchGroupTestDuplicateElimination(rm, result);
			if ( "Right".equals(result) ) {
				result = rmMatchGroupTestMessageOrder(rm, result);
				if ( "Right".equals(result) ) {
					result = rmMatchGroupTestWhenLastRmExisted(rm, result);
					if ( "Right".equals(result) ) {
						result = rmMatchGroupExpiryTimeAndMaxIdleDuration(rm, result);
					}
				}
			}
		}
	}
	return result;
	}
	
	public String rmMatchGroupExpiryTimeAndMaxIdleDuration(ReliableMessage rm, String result) {
	if ( this.groupExpiryTime == null &&  -1 == this.groupMaxIdleDuration ) {			System.out.println("Group.rmMatchGroupExpiryTimeAndMaxIdleDuration(): Impossible path");
	} else if ( this.groupExpiryTime == null &&  -1 != this.groupMaxIdleDuration ) {
				String sGroupMaxIdleDuration = rm.getIMessageContext().getRequestServices().selector("Envelope" +
				"\\Header\\Request\\MessageId\\SequenceNum", "groupMaxIdleDuration");
		String sGroupExpiryTime = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
				"\\Request\\MessageId\\SequenceNum", "groupExpiryTime");
		if ( sGroupMaxIdleDuration == null ) {
			result = "InvalidMessageParameters -- the RM parameter is not agreed with the group Parameter";
		}
		if ( sGroupExpiryTime != null ) {
			result = "InvalidMessageParameters -- the RM parameter is not agreed with the group Parameter";
		}
	} else if ( this.groupExpiryTime != null &&  -1 == this.groupMaxIdleDuration ) {
				String sGroupMaxIdleDuration = rm.getIMessageContext().getRequestServices().selector("Envelope" +
				"\\Header\\Request\\MessageId\\SequenceNum", "groupMaxIdleDuration");
		String sGroupExpiryTime = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
				"\\Request\\MessageId\\SequenceNum", "groupExpiryTime");
		if ( sGroupMaxIdleDuration != null ) {
			result = "InvalidMessageParameters -- the RM parameter is not agreed with the group Parameter";
		}
		if ( sGroupExpiryTime == null ) {
			result = "InvalidMessageParameters -- the RM parameter is not agreed with the group Parameter";
		}
	}
	return result;
	}
	
	
	public String rmMatchGroupTestWhenLastRmExisted(ReliableMessage rm, String result) {
	if ( this.lastRM != null ) {			String sLastNumber = this.lastRM.getIMessageContext().getRequestServices().selector("Envelope" +
				"\\Header\\Request\\MessageId\\SequenceNum", "number");
		if ( sLastNumber != null) {				long last = WSRMUtil.stringParseLong(sLastNumber);
			String sRM = rm.getIMessageContext().getRequestServices().selector("Envelope" +
							"\\Header\\Request\\MessageId\\SequenceNum", "number");
			long number = WSRMUtil.stringParseLong(sRM);
			if ( number >= 0 && number <= last ) {
				result = "Right";
			} else {
				result = "InvalidMessageId -- SequenceNum's @number's value is illegal, " +
						"the value exceeds the RM @last value of the group or less than 0 ";
			}
		} else {				result = "InvalidMessageId -- 'SequenceNum' does not occur in this group, " +
					"and this group is only permitted to have 1 message";
		}
	}
	return result;
	}
	
	public String rmMatchGroupTestGroupId(ReliableMessage rm, String result) {
	String  s = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
			"\\Request\\MessageId", "groupId");
	if ( !this.groupId.equals(s) ) {
		result = "InvalidMessageId -- SequenceNum's @groupId's value is illegal, " +
				"and groupId's value is not the same";
	}
	return result;
	}
	
	public String rmMatchGroupTestAckRequested(ReliableMessage rm, String result) {
	String s = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header\\Request\\AckRequested");
	if ( !( this.GuaranteedDelivery == ( "AckRequested".equals(s) ) ) ) {
		result = "InvalidRequest -- Illegal 'AckRequested', " +
				"and this rm's 'AckRequested' agreement is not agreed with the group";
	}
	return result;
	}
	
	
	public String rmMatchGroupTestDuplicateElimination(ReliableMessage rm, String result) {
	String s = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header\\" +
			"Request\\DuplicateElimination");
	if ( !( this.NoDuplicateDelivery == ( "DuplicateElimination".equals(s) ) ) ) {
		result = "InvalidRequest -- Illegal 'DuplicateElimination', " +
				"and this rm's 'DuplicateElimination' agreement is not agreed with the group";
	}
	return result;
	}
	
	
	public String rmMatchGroupTestMessageOrder(ReliableMessage rm, String result) {
	String s = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header\\Request\\MessageOrder");
	if ( !( this.OrderedDelivery == ( "MessageOrder".equals(s) ) ) ) {
		result = "InvalidRequest -- Illegal 'MessageOrder', " +
				"and this rm's 'MessageOrder' agreement is not agreed with the group";
	}
	return result;
	}
	
	
	public int isDuplicated(ReliableMessage rm) {
	int result = -1;
	ReliableMessage temp = null;
	String sTemp = null, sRM = null;
	for ( int i = 0 ; i < this.AL.size() ; i ++ ) {
		temp = (ReliableMessage)this.AL.get(i);
		sTemp = temp.getIMessageContext().getRequestServices().selector("Envelope\\Header\\" +
				"Request\\MessageId\\SequenceNum", "number");
		sRM = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header\\" +
				"Request\\MessageId\\SequenceNum", "number");
		if ( sTemp.equals(sRM) ) {				result = i;
			break;
		}
	}
	return result;
	}
	
	
	public boolean hasUnderliveredRMExpiryOrFault() {
	boolean result = false;
	ReliableMessage rm = null;
	Date date = null;
	for ( int i = 0 ; i < this.AL.size() ; i ++ ) {
		rm = (ReliableMessage)this.AL.get(i);
		date = rm.getExpiryTime(); 
		if ( ( rm.getState() == rm.UndeliveredFault ) || 
				( ( true == WSRMUtil.testExpiry(date) ) && ( rm.getState() == rm.UndeliveredWait ) ) ) {
			result = true;
		}
	}
	return result;
	}
	
	
	public boolean hasUnacknowledgedRMExpiryOrFault() {
	boolean result = false;
	ReliableMessage rm = null;
	Date date = null;
	for ( int i = 0 ; i < this.AL.size() ; i ++ ) {
		rm = (ReliableMessage)this.AL.get(i);
		date = rm.getExpiryTime();
		if ( ( true == WSRMUtil.testExpiry(date) && ( rm.getState() == rm.SentAndNotNotify )) 
				|| ( rm.SentAndNotifyFault == rm.getState() ) ) {
			result = true;
		}
	}
	return result;
	}
	
	
	public boolean allHasGetAckOrFault() {
	boolean result = true;
	ReliableMessage rm = null;
	for ( int i = 0 ; i < this.AL.size() ; i ++ ) {
		rm = (ReliableMessage)this.AL.get(i);
		if ( rm.SentAndNotNotify == rm.getState() ) {
			result = false;
			break;
		}
	}
	return result;
	}
	
	
	public boolean lastSent() {
	boolean result = false;
	if ( this.lastRM != null  && 
			( this.lastRM.getState() == this.lastRM.SentAndNotifyAck || 
					this.lastRM.getState() == this.lastRM.SentAndNotifyFault || 
						this.lastRM.getState() == this.lastRM.SentAndNotNotify ) ) {
		result = true;
	}
	return result;
	}
	
	
	public boolean allRmSent() {
	boolean result = true;
	ReliableMessage rm = null;
	for ( int i = 0 ; i < this.AL.size() ; i ++ ) {
		rm = (ReliableMessage)this.AL.get(i);
		if ( rm.NotSent == rm.getState() ) {
			result = false;
			break;
		}
	}
	return result;
	}
	
	
	public boolean lastReceived() {
	boolean result = false;
	if ( this.lastRM != null ) {
		result = true;
	}
	return result;
	}
	
	
	public boolean allPreviousReceived() {
	 
	boolean result = false;
	String sLastNumber = this.lastRM.getIMessageContext().
			getRequestServices().selector("Envelope\\Header\\" +
			"Request\\MessageId\\SequenceNum", "number");
	if ( sLastNumber!= null ) {
		long last = WSRMUtil.stringParseLong(sLastNumber);
		
		if ( last == ( (long)this.AL.size() ) ) {
			result = true;
		}
	} else {	
		 
		result = true;
	}
	return result;
	}
	
	
	public void sort() {		if ( this.AL.size() > 1 ) {
		ReliableMessage tempA = null, tempB = null;
		long a = 0L, b = 0L;
		for ( int i = 0 ; i < this.AL.size() ; i ++ ) {
			for ( int j = 0 ; j < this.AL.size() - i - 1 ; j ++ ) {
				a = ( (ReliableMessage) this.AL.get(j) ).getNumber();
				b = ( (ReliableMessage) this.AL.get(j + 1) ).getNumber();
				if ( a > b ) {						tempA = (ReliableMessage) this.AL.get(j);
					tempB = (ReliableMessage) this.AL.get(j + 1);
					this.AL.set(j, tempB);
					this.AL.set(j + 1, tempA);
				}
			} 
		}
	} else { 	}
	}

	
	

	
		
	public void stateUpdate(int rmpCurrentRole) { 		if ( ReceivingRMP == rmpCurrentRole ) {			if ( lastReceived() && allPreviousReceived() ) {
			this.state = Completed;
		}
	} else if ( SendingRMP == rmpCurrentRole ) {			if ( lastSent() && allRmSent() ) {
			this.state = Completed;
		}
	} else { 	}
		boolean completed = false;
	completed = stateUpdateToClosed(rmpCurrentRole, completed);
	stateUpdateToRemoved(rmpCurrentRole, completed);
	}
		
	public boolean stateUpdateToClosed(int rmpCurrentRole, boolean completed) {
	if ( Running == this.state || Completed == this.state ) {
		if ( ReceivingRMP == rmpCurrentRole ) {				completed = stateUpdateToClosedinReceivingRMP(completed);
		} else if ( SendingRMP == rmpCurrentRole ) {				completed = stateUpdateToClosedinSendingRMP(completed);
		} else { 		}
	}
	return completed;
	}
	
	public boolean stateUpdateToClosedinReceivingRMP(boolean completed) {
	if ( this.groupExpiryTime != null && WSRMUtil.testExpiry( this.groupExpiryTime ) == true ) {
		this.state = Closed;
	} else if ( this.groupMaxIdleDuration != -1 && 
			WSRMUtil.testExpiry( this.startTime + (long) ( this.groupMaxIdleDuration * 1000 ) ) ) {
		this.state = Closed;
	} else if ( Completed == this.state ) {
		this.state = Closed;
		completed = true;
	} else if ( ( this.OrderedDelivery == true ) && ( hasUnderliveredRMExpiryOrFault() == true ) ) {
		this.state = Closed;
	} else { 	}
	return completed;
	}
	
	
	public boolean stateUpdateToClosedinSendingRMP(boolean completed) {
	if ( this.groupExpiryTime != null && WSRMUtil.testExpiry( this.groupExpiryTime ) == true ) {
		this.state = Closed;
	} else if ( this.groupMaxIdleDuration != -1 && 
			WSRMUtil.testExpiry( this.startTime + (long) ( this.groupMaxIdleDuration * 1000 ) ) ) {
		this.state = Closed;
	} else if ( Completed == this.state ) {
		this.state = Closed;
		completed = true;
	} else if ( ( true == this.OrderedDelivery ) && ( hasUnacknowledgedRMExpiryOrFault() == true ) ) {
		this.state = Closed;
	} else { 	}
	return completed;
	}
		
	public void stateUpdateToRemoved(int rmpCurrentRole, boolean completed) {
		if ( Closed == this.state ) {
		if ( ReceivingRMP == rmpCurrentRole ) {				stateUpdateToRemovedinReceivingRMP(completed);
		} else if ( SendingRMP == rmpCurrentRole ) {				stateUpdateToRemovedinSendingRMP(completed);
		} else { 		}
	}
	}
	
	public void stateUpdateToRemovedinReceivingRMP(boolean completed) {
	if ( this.groupExpiryTime != null && WSRMUtil.testExpiry( this.groupExpiryTime ) == true ) {
		this.state = Removed;
	} else if ( this.groupMaxIdleDuration != -1 && 
			WSRMUtil.testExpiry( this.startTime + (long) ( this.groupMaxIdleDuration * 1000 ) ) ) {
		if ( true == WSRMUtil.testExpiry( getGroupMaxRmExpiryTime() ) ) {
			this.state = Removed;
		}
	} else if ( true == completed ) {
		if ( true == WSRMUtil.testExpiry( getGroupMaxRmExpiryTime() ) ) {
			this.state = Removed;
		}
	} else if ( ( true == this.OrderedDelivery ) && ( hasUnderliveredRMExpiryOrFault() == true ) ) {
		if ( true == WSRMUtil.testExpiry( getGroupMaxRmExpiryTime() ) ) {
			this.state = Removed;
		}
	} else { 	}
	}
	
	
	public void stateUpdateToRemovedinSendingRMP(boolean completed) {
	if ( this.groupExpiryTime != null && WSRMUtil.testExpiry( this.groupExpiryTime ) == true ) {
		this.state = Removed;
	} else if ( this.groupMaxIdleDuration != -1 && 
			WSRMUtil.testExpiry( this.startTime + (long) ( this.groupMaxIdleDuration * 1000 ) ) ) {
		if ( ( false == this.GuaranteedDelivery ) && ( false == this.ExactOnceDelivery )
			&& ( false == this.OrderedDelivery ) ) {
			this.state = Removed;
		} else {
			if ( true == allHasGetAckOrFault() ) {
				this.state = Removed;
			}
		}
	} else if ( true == completed ) {
		if ( ( false == this.GuaranteedDelivery ) && ( false == this.ExactOnceDelivery )
				&& ( false == this.OrderedDelivery ) ) {
				this.state = Removed;
		} else {
			if ( true == allHasGetAckOrFault() ) {
				this.state = Removed;
			}
		}
	} else if ( ( this.OrderedDelivery == true ) && ( true == allHasGetAckOrFault() ) ) {
		this.state = Removed;
	} else { 	}
	}
}
