
package org.act.services.wsrm;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Random;
import java.util.TimeZone;
import org.act.metaset.Attribute;
import org.act.metaset.QName;
import org.act.metaset.Metaset;
import org.act.services.IMessageContext;
import org.act.services.ITransportContext.RequestTransportContext;
import org.act.services.ITransportContext.ResponseTransportContext;
import org.act.services.protocol.http.HTTPURLResponseTransportContext;

public class ReliableMessage implements IReliableMessage, Cloneable{
	
	
	
	public final int InitType 			 = -1;
	public final int RequestType 		 =  0;
	public final int ResponseType 		 =  1;
	public final int RequestResponseType =  2;
	public final int PollRequestType 	 =  3;
	private int type;
	
	
	
	public final int SoapOneWay 		 = 0;
	public final int SoapRequestResponse = 1;
	private int SoapMEP;
	
		private IMessageContext mc;
	
	 
	
	private String MessageFormatState;
	
	private String GroupId;
	
	private long number;
	
		private Date ExpiryTime;
	
	private String ReplyPatternValue;
	
	private boolean GuaranteedDelivery;
	private boolean NoDuplicateDelivery;
	private boolean ExactlOnceDelivery;
	private boolean OrderedDelivery;
	
	
	
	public final int Initial            =  0;
	
	public final int DeliveredRight     =  1;
	public final int UndeliveredFault   =  2;
	public final int UndeliveredWait    =  3;
	
	public final int SentAndNotifyAck   = -1;
	public final int SentAndNotifyFault = -2;
	public final int SentAndNotNotify   = -3;
	public final int NotSent            = -4;
	
	private int state;
	
	
	public ReliableMessage() {
	super();
	init();
	}
	
	public ReliableMessage adjustRM(ReliableMessage rm) {
			if ( "Response".equals( rm.getReplyPatternValue() ) ) {			rm = reliableMessageByResponseType(rm);
	} else if ( "Callback".equals( rm.getReplyPatternValue() ) ) {						rm = reliableMessageByCallbackType(rm);
		String url = null;
		Metaset BareURI = rm.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
									"\\Request\\ReplyPattern\\ReplyTo\\BareURI");
		if ( BareURI != null ) {				String URI = ( (Metaset) BareURI.getChilds().get(0) ).getValue();
			url = URI;
		} else {				String rs = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
					"\\Request\\ReplyPattern\\ReplyTo", "reference-scheme");
			url = rs;
		}
		RequestTransportContext httpContext = (RequestTransportContext) new HTTPURLResponseTransportContext(url);
		rm.getIMessageContext().setResponseTransportContext((ResponseTransportContext) httpContext);
			} else {			
		rm = reliableMessageByPollType(rm);
	}
	return rm;
	}
	
	
	public ReliableMessage reliableMessageByResponseType(ReliableMessage rm) {
	this.mc = rm.getIMessageContext();
	Metaset Response = new Metaset("wsrm", "Response");
	Response.add(new Attribute(new QName("xmlns", "wsrm"), 
		"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
	Response.add(new Attribute(new QName("xmlns", "soap12"), "http://www.w3.org/2003/05/soap-envelope"));
	Response.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
	Metaset test = rm.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
						"\\Request\\MessageId\\SequenceNum");
	if ( test != null ) { 
		Metaset SequenceReplies = new Metaset("wsrm", "SequenceReplies");
		SequenceReplies.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
		Metaset ReplyRange = new Metaset("wsrm", "ReplyRange");
		ReplyRange.add(new Attribute( new QName("xsd", "from"), Long.toString(rm.getNumber())));
		ReplyRange.add(new Attribute( new QName("xsd", "to"), Long.toString(rm.getNumber())));
		SequenceReplies.add(ReplyRange);
		Response.add(SequenceReplies);
	} else {
		Metaset NonSequenceReply = new Metaset("wsrm", "NonSequenceReply");
		NonSequenceReply.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
		Response.add(NonSequenceReply);
	}
	Metaset Header = (Metaset)( (Metaset)this.getIMessageContext().
			getResponseServices().filter(".\\Header") ).getChilds().get(0);
	Metaset RequestSet = (Metaset)( (Metaset)this.getIMessageContext().
			getResponseServices().filter(".\\Header\\Request") );
	if ( RequestSet == null ) {
			} else {
		Metaset Request = (Metaset)RequestSet.getChilds().get(0);
		Header.remove(Request);
	}
	Header.add(Response);
	return rm;
	}
	
	
	public ReliableMessage reliableMessageByCallbackType(ReliableMessage rm) {
		Metaset Envelope = new Metaset("soapenv","Envelope");
	Envelope.add(new Attribute(new QName("xmlns","soapenv"),"http://schemas.xmlsoap.org/soap/envelope/"));
	Envelope.add(new Attribute(new QName("xmlns","xsi"),"http://www.w3.org/2001/XMLSchema-instance"));
	Envelope.add(new Attribute(new QName("xmlns","xsd"),"http://www.w3.org/2001/XMLSchema"));
	Envelope.add(new Attribute(new QName("xmlns","soapenc"),"http://schemas.xmlsoap.org/soap/encoding/"));
	Metaset Header = new Metaset("soapenv", "Header");
	Metaset Response = new Metaset("wsrm", "Response");
	Response.add(new Attribute(new QName("xmlns", "wsrm"), 
			"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
	Response.add(new Attribute(new QName("xmlns", "soap12"), "http://www.w3.org/2003/05/soap-envelope"));
	Response.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
							"\\Request\\MessageId\\SequenceNum");
	if ( test != null ) { 
		Metaset SequenceReplies = new Metaset("wsrm", "SequenceReplies");				
		SequenceReplies.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
		
		Metaset ReplyRange = new Metaset("wsrm", "ReplyRange");
		ReplyRange.add(new Attribute( new QName("xsd", "from"), Long.toString(rm.getNumber())));
		ReplyRange.add(new Attribute( new QName("xsd", "to"), Long.toString(rm.getNumber())));
		
		SequenceReplies.add(ReplyRange);
		Response.add(SequenceReplies);
	} else {
		Metaset NonSequenceReply = new Metaset("wsrm", "NonSequenceReply");
		NonSequenceReply.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
		Response.add(NonSequenceReply);
	}
	Header.add(Response);
	Envelope.add(Header);
	return rm;
	}
	
	public ReliableMessage reliableMessageByPollType(ReliableMessage rm) {
	this.mc = rm.getIMessageContext();
	Metaset Response = new Metaset("wsrm", "Response");
	Response.add(new Attribute(new QName("xmlns", "wsrm"), 
		"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
	Response.add(new Attribute(new QName("xmlns", "soap12"), "http://www.w3.org/2003/05/soap-envelope"));
	Response.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
	Metaset test = rm.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
						"\\Request\\MessageId\\SequenceNum");
	if ( test != null ) { 
		Metaset SequenceReplies = new Metaset("wsrm", "SequenceReplies");
		SequenceReplies.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
		Metaset ReplyRange = new Metaset("wsrm", "ReplyRange");
		ReplyRange.add(new Attribute( new QName("xsd", "from"), Long.toString(rm.getNumber())));
		ReplyRange.add(new Attribute( new QName("xsd", "to"), Long.toString(rm.getNumber())));
		SequenceReplies.add(ReplyRange);
		Response.add(SequenceReplies);
	} else {
		Metaset NonSequenceReply = new Metaset("wsrm", "NonSequenceReply");
		NonSequenceReply.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
		Response.add(NonSequenceReply);
	}
	Metaset Header = (Metaset)( (Metaset)this.getIMessageContext().
			getResponseServices().filter(".\\Header") ).getChilds().get(0);
	Header.remove( (Metaset)Header.getChilds().get(0) );
	Header.add(Response);
		return rm;
	}
	
	
	public ReliableMessage setFaultResponse(ReliableMessage rm) {
		this.mc = rm.getIMessageContext();
	if ( "Response".equals( rm.getReplyPatternValue() ) ) {			rm = setFaultResponseByResponseType(rm);
	} else if ( "Callback".equals( rm.getReplyPatternValue() ) ) { 				rm = setFaultResponseByCallbackType(rm);
		String url = null;
		Metaset BareURI = rm.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
									"\\Request\\ReplyPattern\\ReplyTo\\BareURI");
		if ( BareURI != null ) {				String URI = ( (Metaset) BareURI.getChilds().get(0) ).getValue();
			url = URI;
		} else {				String rs = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
					"\\Request\\ReplyPattern\\ReplyTo", "reference-scheme");
			url = rs;
		}
		RequestTransportContext httpContext = (RequestTransportContext) new HTTPURLResponseTransportContext(url);
		rm.getIMessageContext().setResponseTransportContext((ResponseTransportContext) httpContext);
	} else { 		rm = setFaultResponseByPollType(rm);
	}
	return rm;
	}
	
	
	public ReliableMessage setFaultResponseByResponseType(ReliableMessage rm) {
	Metaset Response = new Metaset("wsrm", "Response");
	Response.add(new Attribute(new QName("xmlns", "wsrm"), 
		"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
	Response.add(new Attribute(new QName("xmlns", "soap12"), "http://www.w3.org/2003/05/soap-envelope"));
	Response.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
	Metaset test = rm.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
						"\\Request\\MessageId\\SequenceNum");
	if ( test != null ) { 
		Metaset SequenceReplies = new Metaset("wsrm", "SequenceReplies");
		SequenceReplies.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
		
		Metaset ReplyRange = new Metaset("wsrm", "ReplyRange");
		ReplyRange.add(new Attribute( new QName("xsd", "from"), Long.toString(rm.getNumber())));
		ReplyRange.add(new Attribute( new QName("xsd", "to"), Long.toString(rm.getNumber())));
		
				ReplyRange.add(new Attribute( new QName("xsd", "fault"), rm.getMessageFormatState()));
		
		SequenceReplies.add(ReplyRange);
		Response.add(SequenceReplies);
	} else {
		Metaset NonSequenceReply = new Metaset("wsrm", "NonSequenceReply");
		NonSequenceReply.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
				NonSequenceReply.add(new Attribute( new QName("xsd", "fault"), rm.getMessageFormatState()));
		Response.add(NonSequenceReply);
	}
		Metaset envelope = new Metaset("soapenv", "Envelope");
	envelope.add(new Attribute( new QName("xmlns", "soapenv"), "http://schemas.xmlsoap.org/soap/envelope/") );
	envelope.add(new Attribute( new QName("xmlns", "xsi"), "http://www.w3.org/2001/XMLSchema-instance") );
	envelope.add(new Attribute( new QName("xmlns", "xsd"), "http://www.w3.org/2001/XMLSchema") );
	envelope.add(new Attribute( new QName("xmlns", "soapenc"), "http://schemas.xmlsoap.org/soap/encoding/") );
	Metaset header = new Metaset("soapenv", "Header");
	header.add(Response);
	envelope.add(header);
	Metaset body = new Metaset("soapenv", "Body");
	envelope.add(body);
	rm.getIMessageContext().setResponseServices(envelope);
	return rm;
	}
	
	
	public ReliableMessage setFaultResponseByCallbackType(ReliableMessage rm) {
	Metaset Response = new Metaset("wsrm", "Response");
	Response.add(new Attribute(new QName("xmlns", "wsrm"), 
			"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
	Response.add(new Attribute(new QName("xmlns", "soap12"), "http://www.w3.org/2003/05/soap-envelope"));
	Response.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
							"\\Request\\MessageId\\SequenceNum");
	if ( test != null ) { 
		Metaset SequenceReplies = new Metaset("wsrm", "SequenceReplies");				
		SequenceReplies.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
		Metaset ReplyRange = new Metaset("wsrm", "ReplyRange");
		ReplyRange.add(new Attribute( new QName("xsd", "from"), Long.toString(rm.getNumber())));
		ReplyRange.add(new Attribute( new QName("xsd", "to"), Long.toString(rm.getNumber())));
				ReplyRange.add(new Attribute( new QName("xsd", "fault"), rm.getMessageFormatState()));
		SequenceReplies.add(ReplyRange);
		Response.add(SequenceReplies);
	} else {
		Metaset NonSequenceReply = new Metaset("wsrm", "NonSequenceReply");
		NonSequenceReply.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
				NonSequenceReply.add(new Attribute( new QName("xsd", "fault"), rm.getMessageFormatState()));
		Response.add(NonSequenceReply);
	}
		Metaset envelope = new Metaset("soapenv", "Envelope");
	envelope.add(new Attribute( new QName("xmlns", "soapenv"), "http://schemas.xmlsoap.org/soap/envelope/") );
	envelope.add(new Attribute( new QName("xmlns", "xsi"), "http://www.w3.org/2001/XMLSchema-instance") );
	envelope.add(new Attribute( new QName("xmlns", "xsd"), "http://www.w3.org/2001/XMLSchema") );
	envelope.add(new Attribute( new QName("xmlns", "soapenc"), "http://schemas.xmlsoap.org/soap/encoding/") );
	Metaset header = new Metaset("soapenv", "Header");
	header.add(Response);
	envelope.add(header);
	Metaset body = new Metaset("soapenv", "Body");
	envelope.add(body);
	rm.getIMessageContext().setResponseServices(envelope);
	return rm;
	}
	
	public ReliableMessage setFaultResponseByPollType(ReliableMessage rm) {
	Metaset Response = new Metaset("wsrm", "Response");
	Response.add(new Attribute(new QName("xmlns", "wsrm"), 
		"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
	Response.add(new Attribute(new QName("xmlns", "soap12"), "http://www.w3.org/2003/05/soap-envelope"));
	Response.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
	Metaset test = rm.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
						"\\Request\\MessageId\\SequenceNum");
	if ( test != null ) { 
		Metaset SequenceReplies = new Metaset("wsrm", "SequenceReplies");
		SequenceReplies.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
		Metaset ReplyRange = new Metaset("wsrm", "ReplyRange");
		ReplyRange.add(new Attribute( new QName("xsd", "from"), Long.toString(rm.getNumber())));
		ReplyRange.add(new Attribute( new QName("xsd", "to"), Long.toString(rm.getNumber())));
				ReplyRange.add(new Attribute( new QName("xsd", "fault"), rm.getMessageFormatState()));
		SequenceReplies.add(ReplyRange);
		Response.add(SequenceReplies);
	} else {
		Metaset NonSequenceReply = new Metaset("wsrm", "NonSequenceReply");
		NonSequenceReply.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
				NonSequenceReply.add(new Attribute( new QName("xsd", "fault"), rm.getMessageFormatState()));
		Response.add(NonSequenceReply);
	}		
		Metaset envelope = new Metaset("soapenv", "Envelope");
	envelope.add(new Attribute( new QName("xmlns", "soapenv"), "http://schemas.xmlsoap.org/soap/envelope/") );
	envelope.add(new Attribute( new QName("xmlns", "xsi"), "http://www.w3.org/2001/XMLSchema-instance") );
	envelope.add(new Attribute( new QName("xmlns", "xsd"), "http://www.w3.org/2001/XMLSchema") );
	envelope.add(new Attribute( new QName("xmlns", "soapenc"), "http://schemas.xmlsoap.org/soap/encoding/") );
	Metaset header = new Metaset("soapenv", "Header");
	header.add(Response);
	envelope.add(header);
	Metaset body = new Metaset("soapenv", "Body");
	envelope.add(body);
	rm.getIMessageContext().setResponseServices(envelope);
	return rm;
	}
	
	
	public Object clone() throws CloneNotSupportedException {
	ReliableMessage result = (ReliableMessage) super.clone();
	result.type = this.type;
	result.SoapMEP = this.SoapMEP;
		result.mc = (IMessageContext) this.mc.clone();
	result.MessageFormatState = this.MessageFormatState;
	result.GroupId = this.GroupId;
	result.number = this.number;
	result.ExpiryTime = (Date) this.ExpiryTime.clone();
	result.ReplyPatternValue = this.ReplyPatternValue;
	result.GuaranteedDelivery = this.GuaranteedDelivery;
	result.NoDuplicateDelivery = this.NoDuplicateDelivery;
	result.ExactlOnceDelivery = this.ExactlOnceDelivery;
	result.OrderedDelivery = this.OrderedDelivery;
	result.state = this.state;
	return result;
	}
	
	
	public void init() {	
	initRmTypeRequestResponsePollRequest();
	initSoapMepType();
	initRmParameters();
	initRMAgreements();
	initRmState();
	}
	
	public void initRmTypeRequestResponsePollRequest() {
	this.type = InitType;
	}
	
	public void initSoapMepType() {
	this.SoapMEP = SoapRequestResponse;
	}
	
	public void initRmParameters() {
	this.mc = null;
	this.MessageFormatState = "Right";
	this.GroupId = null;
	this.number = -1L;
	this.ExpiryTime = null;
	this.ReplyPatternValue = null;
	}
	
	public void initRMAgreements() {
	this.GuaranteedDelivery = false;
	this.NoDuplicateDelivery = false;
	this.ExactlOnceDelivery = false;
	this.OrderedDelivery = false;
	}
	
	public void initRmState() {
	this.state = Initial;
	}
	
	private static Random r = new Random(129304901243092394L);
	
	
	public void initSetRequest() {
	Metaset RequestSet = null;
	if ( this.getIMessageContext().getRequestServices() == null ) {
						return;
	} else { 		RequestSet = (Metaset)( (Metaset)this.getIMessageContext().
				getRequestServices().filter(".\\Header\\Request") );
				if (RequestSet == null) {
									Metaset ResponseSet = (Metaset)( (Metaset)this.getIMessageContext().
					getRequestServices().filter(".\\Header\\Response") );
			Metaset PollRequestSet = (Metaset)( (Metaset)this.getIMessageContext().
					getRequestServices().filter(".\\Header\\PollRequest") );
			if (ResponseSet != null || PollRequestSet != null) {
								return;
			} else {
								Metaset request = new Metaset("wsrm", "Request");
				request.add(new Attribute(new QName("xmlns", "wsrm"), 
						"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
				request.add(new Attribute(new QName("xmlns", "soap12"), "http://www.w3.org/2003/05/soap-envelope"));
				request.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
				Metaset messageId = new Metaset("wsrm", "MessageId");
								String groupId = "" + System.currentTimeMillis() + r.nextLong();
				messageId.add(new Attribute(new QName("xsd", "groupId"), groupId));
				Metaset sequenceNum = new Metaset("wsrm", "SequenceNum");
								sequenceNum.add(new Attribute(new QName("xsd", "number"), "0"));
								sequenceNum.add(new Attribute(new QName("xsd", "groupExpiryTime"), "2008-09-17T08:08:08-2:00"));
				sequenceNum.add(new Attribute(new QName("xsd", "last"), "true"));
				messageId.add(sequenceNum);
				request.add(messageId);
				Metaset expiryTime = new Metaset("wsrm", "ExpiryTime");
				expiryTime.setValue("2008-08-08T08:08:08-28:00");
				request.add(expiryTime);
				Metaset replyPattern = new Metaset("wsrm", "ReplyPattern");
				Value value = new Value("wsrm", "Value");
				value.setValue("Response");
				replyPattern.add(value);
				request.add(replyPattern);
				Metaset ackRequested = new Metaset("wsrm", "AckRequested");
				request.add(ackRequested);
				Metaset duplicateElimination = new Metaset("wsrm", "DuplicateElimination");
				request.add(duplicateElimination);
								Metaset envelope = (Metaset) this.getIMessageContext().getRequestServices();
				Metaset header = (Metaset)(envelope.filter(".\\Header"));
								if (header == null) {
					header = new Metaset("soapenv", "Header");
					header.add(request);
					Metaset body = new Metaset("Body");
					body = (Metaset)envelope.getChilds().get(0);
					envelope.remove(body);
										envelope.add("Envelope\\", header);
					envelope.add(body);
				} else { 					header = (Metaset)( (Metaset)this.getIMessageContext().
							getRequestServices().filter(".\\Header") ).getChilds().get(0);
					header.add(request);
				}
			}
		} else { 		}
	}
	}
	
	
	public void initSetResponse() {
	Metaset Response = new Metaset("wsrm", "Response");
	Response.add(new Attribute(new QName("xmlns", "wsrm"), 
			"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
	Response.add(new Attribute(new QName("xmlns", "soap12"), "http://www.w3.org/2003/05/soap-envelope"));
	Response.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
	Metaset NonSequenceReply = new Metaset("wsrm", "NonSequenceReply");
	NonSequenceReply.add(new Attribute(new QName("xsd", "groupId"), "mid://20040202.103832@wsr-sender.org"));
	Response.add(NonSequenceReply);
		Metaset envelope = (Metaset) this.getIMessageContext().getResponseServices();
	Metaset header = (Metaset)(envelope.filter(".\\Header"));
		if (header == null) {
		return;
	} else {
		header = (Metaset)( envelope.filter(".\\Header") ).getChilds().get(0);
		Metaset RequestSet = (Metaset)( envelope.filter(".\\Header\\Request") );
		if ( RequestSet == null ) {
					} else {
			Metaset Request = (Metaset)RequestSet.getChilds().get(0);
			header.remove(Request);
		}
		header.add(Response);
	}
	}
	
	
	public int getType() {
	return type;
	}
	
	
	public void setType(int iType) {
	this.type = iType;
	}
	
	
	public int getSoapMEP() {
	return SoapMEP;
	}
	
	
	public void setSoapMEP(int mep) {
	this.SoapMEP = mep;
	}
	
	
	public IMessageContext getIMessageContext() {
	return mc;
	}
	
	
	public void setIMessageContext(IMessageContext mc) {
	this.mc = mc;
	}
	
	
	public String getMessageFormatState() {
	return MessageFormatState;
	}
	
	
	public void setMessageFormatState(String state) {
	this.MessageFormatState = state;
	}
		
	
	public String getGroupId () {
	return GroupId;
	}
	
	
	public void setGroupId(String ID) {
	this.GroupId = ID;
	}
	
	
	public long getNumber() {
	return number;
	}
	
	
	public void setNumber(long number) {
	this.number = number;
	}
	
	
	public Date getExpiryTime() {
	return ExpiryTime;
	}
	
	
	public void setExpiryTime(Date pDate) {
	this.ExpiryTime = pDate;
	}
	
	
	public String getReplyPatternValue() {
	return ReplyPatternValue;
	}
	
	
	public void setReplyPatternValue(String value) {
	this.ReplyPatternValue = value;
	}
	
	
	public boolean getGuaranteedDelivery() {
	return GuaranteedDelivery;
	}
	
	
	public void setGuaranteedDelivery(boolean b) {
	this.GuaranteedDelivery = b;
	}
	
	
	public boolean getNoDuplicateDelivery() {
	return NoDuplicateDelivery;
	}
	
	
	public void setNoDuplicateDelivery(boolean b) {
	this.NoDuplicateDelivery = b;
	}
	
	
	public boolean getExactlOnceDelivery() {
	return ExactlOnceDelivery;
	}
	
	
	public void setExactlOnceDelivery(boolean b) {
	this.ExactlOnceDelivery = b;
	}
	
	
	public boolean getOrderedDelivery() {
	return OrderedDelivery;
	}
	
	
	public void setOrderedDelivery(boolean b) {
	this.OrderedDelivery = b;
	}	
	
	
	public int getState() {
	return state;
	}
	
	
	public void setState(int state) {
	this.state = state;
	}
	
		
	public boolean whetherIsLast() {
	boolean result = false;
	Metaset test = null;
	if (this.getIMessageContext().getRequestServices() != null) {
		test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
				"\\Request\\MessageId\\SequenceNum");
	} else {
		test = this.getIMessageContext().getResponseServices().filter("Envelope\\Header" +
				"\\Request\\MessageId\\SequenceNum");
	}
	if ( test!= null ) {
		List list = ( (Metaset)test.getChilds().get(0) ).getAttributes();
		String s = null;
		for ( int i = 0 ; i < list.size() ; i ++ ) {
			s = ((Attribute)list.get(i)).getName();
			if ( "last".equals(s) ) {
				String value  = null;
				if (this.getIMessageContext().getRequestServices() != null) {
					value = this.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
						"\\Request\\MessageId\\SequenceNum", "last");
				} else {
					value = this.getIMessageContext().getResponseServices().selector("Envelope\\Header" +
							"\\Request\\MessageId\\SequenceNum", "last");
				}
				if ( "true".equals(value) ) {
					result = true;
					break;
				}
			}
		}
	} else {			result = true;
	}
	return result;
	}
	
	
	
	public String testWhetherIsRM(String INorOUT) {
	String result = "Wrong";
	if ( "IN".equals(INorOUT) ) {
		return testWhetherIsRM_IN(result);
	} else {			return testWhetherIsRM_OUT(result);
	}
	}
	
	public String testWhetherIsRM_IN(String result) {
	if ( this.mc.getRequestServices() == null ) {
		return result;
	}
	String request = null, pollrequest = null, response = null;
	request = this.mc.getRequestServices().selector("Envelope\\Header\\Request");
	pollrequest = this.mc.getRequestServices().selector("Envelope\\Header\\PollRequest");
	response = this.mc.getRequestServices().selector("Envelope\\Header\\Response");
	String xmlnsRequest     = this.mc.getRequestServices().selector("Envelope\\Header\\Request",     "xmlns");
	String wsrmRequest      = this.mc.getRequestServices().selector("Envelope\\Header\\Request",     "wsrm");
	String xmlnsResponse    = this.mc.getRequestServices().selector("Envelope\\Header\\Response",    "xmlns");
	String wsrmResponse     = this.mc.getRequestServices().selector("Envelope\\Header\\Response",    "wsrm");
	String xmlnsPollRequest = this.mc.getRequestServices().selector("Envelope\\Header\\PollRequest", "xmlns");
	String wsrmPollRequest  = this.mc.getRequestServices().selector("Envelope\\Header\\PollRequest", "wsrm");
	if ( "http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(xmlnsRequest) || 
		"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(wsrmRequest) ||
			"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(xmlnsResponse) || 
				"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(wsrmResponse)  ||
					 "http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(xmlnsPollRequest) ||
					"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(wsrmPollRequest) )
	
	{
		if ( "Request".equals(request) || "Response".equals(response) || "PollRequest".equals(pollrequest) ) {
			result = "Right";
		}
	}
	if ( "Right".equals(result) ) {
		result = testRMType(result);
	} else {
		result = " This is not a Reliable Message, " +
					"because can not find namespace's value of WS-Reliability version 1.1 by OASIA 20040824," +
					"or can not find the element Request or Response or PollRequest";
	}
	return result;
	}
	
	public String testWhetherIsRM_OUT(String result) {
	if ( this.mc.getResponseServices() == null ) {
		return result;
	}
	String request = null, pollrequest = null, response = null;
	request = this.mc.getResponseServices().selector("Envelope\\Header\\Request");
	pollrequest = this.mc.getResponseServices().selector("Envelope\\Header\\PollRequest");
	response = this.mc.getResponseServices().selector("Envelope\\Header\\Response");
	String xmlnsRequest     = this.mc.getResponseServices().selector("Envelope\\Header\\Request",     "xmlns");
	String wsrmRequest      = this.mc.getResponseServices().selector("Envelope\\Header\\Request",     "wsrm");
	String xmlnsResponse    = this.mc.getResponseServices().selector("Envelope\\Header\\Response",    "xmlns");
	String wsrmResponse     = this.mc.getResponseServices().selector("Envelope\\Header\\Response",    "wsrm");
	String xmlnsPollRequest = this.mc.getResponseServices().selector("Envelope\\Header\\PollRequest", "xmlns");
	String wsrmPollRequest  = this.mc.getResponseServices().selector("Envelope\\Header\\PollRequest", "wsrm");
	if ( "http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(xmlnsRequest) || 
		"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(wsrmRequest) ||
			"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(xmlnsResponse) || 
				"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(wsrmResponse)  ||
					 "http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(xmlnsPollRequest) ||
					"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd".equals(wsrmPollRequest) )
	
	{
		if ( "Request".equals(request) || "Response".equals(response) || "PollRequest".equals(pollrequest) ) {
			result = "Right";
		}
	}
	if ( "Right".equals(result) ) {
		result = testRMType(result);
	} else {
		result = " This is not a Reliable Message, " +
					"because can not find namespace's value of WS-Reliability version 1.1 by OASIA 20040824," +
					"or can not find the element Request or Response or PollRequest";
	}
	return result;
	}
	
	public String testRMType(String result) {
	String request = null, pollrequest = null, response = null;
	request = this.mc.getRequestServices().selector("Envelope\\Header\\Request");
	pollrequest = this.mc.getRequestServices().selector("Envelope\\Header\\PollRequest");
	response = this.mc.getRequestServices().selector("Envelope\\Header\\Response");
	Metaset sRequest = null, sResponse = null, sPollRequest = null;
	sRequest = this.mc.getRequestServices().filter("Envelope\\Header\\Request");
	sResponse = this.mc.getRequestServices().filter("Envelope\\Header\\Response");
	sPollRequest = this.mc.getRequestServices().filter("Envelope\\Header\\PollRequest");
		if ( "Request".equals(request) && "Response".equals(response) ){
		if ( sRequest.getChilds().size() > 1 ) {
			result = "InvalidRequest -- Have more than one Request Element";
		}
		if ( sResponse.getChilds().size() > 1 ) {
			result = "InvalidResponse -- Have more than one Response Element";
		}
		if ( "Right".equals(result) ) {
			this.type = RequestResponseType;
		}
	}
	if ( "PollRequest".equals(pollrequest) && "Request".equals(request) ) {
		result = "InvalidRequestPollRequest -- " +
				"can not have the Request Element and the PollRequest Element at the same time";
	}
	if ( "PollRequest".equals(pollrequest) && "Response".equals(response) ) {
		result = "InvalidResponsePollRequest -- " +
				"can not have the Response Element and the PollRequest Element at the same time";
	}
	if ( "PollRequest".equals(pollrequest) && ( sPollRequest.getChilds().size() > 1 ) ) {
		result = "InvalidPollRequest -- Have more than one PollRequest Element";
	}
	if ( "Right".equals(result) ) {
		if ( "PollRequest".equals(pollrequest) ) {
			this.type = PollRequestType;
		}
		if ( "Request".equals(request) && !("Response".equals(response)) ) {
			this.type = RequestType;
		}
		if ( !("Request".equals(request)) && "Response".equals(response) ) {
			this.type = ResponseType;
		}
	}
	return result;
	}
	
	
	public void testMessageFormatFault() throws TestMessageFormatException {
	try {	
				switch (type)
		{
			case RequestType :
				this.MessageFormatState = testRequestElement();
				break;
			case ResponseType :
				this.MessageFormatState = testResponseElement();
				break;
			case RequestResponseType :
				this.MessageFormatState = testRequestElement();
				if ( "Right".equals(this.MessageFormatState) ) {
					this.MessageFormatState = testResponseElement();
				}
				break;
			case PollRequestType :
				this.MessageFormatState = testPollRequestElement();
				break;
			default:
				break;
		}
	} catch (Exception ex) {
		ex.printStackTrace();
	}
	}
	

	
	
	
	
	public String testRequestElement() {		String result = "Right";
		result = testRequestElementMessageId(result);		if ( "Right".equals(result) ) {
		result = testRequestElementExpiryTime(result);			if ( "Right".equals(result) ) {
			result = testRequestElementReplyPattern(result);				if ( "Right".equals(result) ) {
				result = testRequestElementAckRequested(result);
				if ( "Right".equals(result) ) {
					result = testRequestElementMessageOrder(result);
					if ( "Right".equals(result) ) {
						result = testRequestElementDuplicateElimination(result);
						if ( "Right".equals(result) ) {
							result = testRequestElementRMAgreementType(result);
							if ( "Right".equals(result) ) {
								result = testRequestElementSoapmustUnderstand(result);
							}
						}
					}
				}
			}
		}
	}	
	return result;
	}
	
	public String testRequestElementMessageId(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\MessageId");
	if ( 0 == test.getChilds().size() ) {
		result = "InvalidRequest -- Have no MessageId Element";
	} else if ( test.getChilds().size() > 1 ){
		result = "InvalidRequest -- Have more than one MessageId Element";
	} else {			result = testRequestElementMessageIdGroupId(result);
		if ( "Right".equals(result) ) {				result = testRequestElementMessageIdSequenceNum(result);
		}
	}
	return result;
	}
	
	public String testRequestElementExpiryTime(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\ExpiryTime");
	if ( 0 == test.getChilds().size() ) {
		result = "InvalidRequest -- Have no ExpiryTime Element";
	} else if ( test.getChilds().size() > 1 ){
		result = "InvalidRequest -- Have more than one ExpiryTime Element";
	} else {
		
		result = testRequestElementExpiryTimeFormatFault(result, test);
	}
	return result;
	}
	
	public String testRequestElementExpiryTimeFormatFault(String result, Metaset test) {
		String s = ( (Metaset)test.getChilds().get(0) ).getValue();
	SimpleDateFormat SDF = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss-HH:mm");
    SDF.setTimeZone(TimeZone.getTimeZone("UTC"));
    Date date = new Date();
    try {
    	date = SDF.parse(s);
    	this.ExpiryTime = date;
    }
    catch (ParseException ex) {
    	    	result = "InvalidExpiryTime -- the format of the 'ExpiryTime' illegally";
    }
	return result;
	}
	
	
	public String testRequestElementReplyPattern(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\ReplyPattern");
	if ( 0 == test.getChilds().size() ) {
		result = "InvalidRequest -- Have no ReplyPattern Element";
	} else if ( test.getChilds().size() > 1 ) {
		result = "InvalidRequest -- Have more than one ReplyPattern Element";
	} else {
		result = testRequestElementReplyPatternValueAndReplyTo(result);
	}
	return result;
	}
	
	public String testRequestElementReplyPatternValueAndReplyTo(String result) {
	Metaset test;
		test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
			"\\Request\\ReplyPattern\\Value");
	if ( test != null ) {
		if ( 0 == test.getChilds().size() ) {
			result = "InvalidReplyPattern -- Have no 'Value' Element";
		} else if ( test.getChilds().size() > 1 ) {
			result = "InvalidReplyPattern -- Have more than one 'Value' Element";
		} else {
			String s = ( (Metaset)test.getChilds().get(0) ).getValue();
			if ( !( "Response".equals(s) || "Callback".equals(s) || "Poll".equals(s) ) ) {
				result = "InvalidReplyPattern -- Wrong value of elemnt 'Value' " +
						"(Right is: Response, Callback or Poll)";
			} else {
				if ( "Response".equals(s) ) {
					this.ReplyPatternValue = "Response";
				} else if ( "Callback".equals(s) ) {
					this.ReplyPatternValue = "Callback";
				} else {						this.ReplyPatternValue = "Poll";
				}
				result = testRequestElementReplyPatternReplyTo(result, s);
			}
		}
	}
	return result;
	}
	
	public String testRequestElementReplyPatternReplyTo(String result, String s) {
	 
	if ( "Callback".equals(s) ) {
		result = testRequestElementReplyPatternReplyToCallback(result);
	} else {			result = testRequestElementReplyPatternReplyToResponseAndPoll(result);
	}
	return result;
	}
	
	public String testRequestElementReplyPatternReplyToCallback(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
			"\\Request\\ReplyPattern\\ReplyTo");
	if ( 0 == test.getChilds().size() ) {
		result = "InvalidReplyPattern -- Have no 'ReplyTo' Element";
	} else if ( test.getChilds().size() > 1 ) {
		result = "InvalidReplyPattern -- Have more than one 'ReplyTo' Element";
	} else {
		result = testRequestElementReplyPatternReplyToCallbackBareURIandReferenceSchema(result);
	}
	return result;
	}
	
	public String testRequestElementReplyPatternReplyToCallbackBareURIandReferenceSchema(String result) {
	Metaset BareURI = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\ReplyPattern\\ReplyTo\\BareURI");
	if ( BareURI.getChilds().size() > 1 ) {
		result = "InvalidReplyPattern -- Have more than one 'BareURI' Element";
	} else {
		Metaset ReplyTo = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
			"\\Request\\ReplyPattern\\ReplyTo");
		List list = ( (Metaset)ReplyTo.getChilds().get(0) ).getAttributes();
		String sRC = null;
		int counter = 0;
		for ( int i = 0 ; i < list.size() ; i ++ ) {
			sRC = ((Attribute)list.get(i)).getName();
			if ( "reference-scheme".equals(sRC) ) {
				counter ++ ;
			}
		}
		if ( 0 == BareURI.getChilds().size() ) {
			if ( counter > 1 ) {
				result = "InvalidReplyPattern -- Have more than one 'reference-scheme' Attribute";
			} else if ( counter < 1 ) {
				result = "InvalidReplyPattern -- Have no 'reference-scheme' Attribute";
			} else {				}
		} else {
			if ( counter >= 1 ) {
				result = "InvalidReplyPattern -- " +
						"'reference-scheme' Attribute can not occur when element 'BareURI' occur";
			} else {				}
		}
	}
	return result;
	}
	
	public String testRequestElementReplyPatternReplyToResponseAndPoll(String result) {
	Metaset test;
	test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\ReplyPattern\\ReplyTo");
	if ( test != null ) {
		result = "InvalidReplyPattern -- " +
				"'ReplyTo' Element can only occur when ReplyPattern value equals 'Response' or 'Poll'";
	} else {		}
	return result;
	}
	
	public String testRequestElementMessageIdGroupId(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\MessageId");
	List list = ( (Metaset)test.getChilds().get(0) ).getAttributes();
	if ( list.size() > 1 ) {
		result = "InvalidMessageId -- Have more than one groupID Attribute";
	} else if ( list.size() < 1 ) {
		result = "InvalidMessageId -- Have no groupID Attribute";
	} else {
		
		setGroupId( getIMessageContext().getRequestServices().selector("Envelope\\Header\\" +
				"Request\\MessageId", "groupId") );
	}
	return result;
	}
	
	public String testRequestElementMessageIdSequenceNum(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\MessageId\\SequenceNum");
	if ( test != null ) {
		result = testRequestElementMessageIdSequenceNumAttributes(result, test);
	}		
	return result;
	}
	
	public String testRequestElementMessageIdSequenceNumAttributes(String result, Metaset test) {
	List list = ( (Metaset)test.getChilds().get(0) ).getAttributes();
	String s = null;
	int counterGroupExpireTime = 0, counterGroupMaxIdleDuration = 0, counterNumber = 0, conterLast = 0;
	for ( int i = 0 ; i < list.size() ; i ++ ) {
		s = ((Attribute)list.get(i)).getName();
		if ( "groupExpiryTime".equals(s) ) {
			counterGroupExpireTime ++ ;
		}
		if ( "groupMaxIdleDuration".equals(s) ) {
			counterGroupMaxIdleDuration ++;
		}
		if ( "number".equals(s) ) {
			counterNumber ++;
		}
		if ( "last".equals(s) ) {
			conterLast ++;
		}
	}
	result = testRequestElementMessageIdSequenceNumAttributeGroupExpireTimeAndGroupMaxIdleDuration
				(result, s, counterGroupExpireTime, counterGroupMaxIdleDuration);
	if ( "Right".equals(result) ) {
		result = testRequestElementMessageIdSequenceNumAttributeNumber(result, counterNumber);
		if ( "Right".equals(result) ) {
			result = testRequestElementMessageIdSequenceNumAttributeLast(result, conterLast);
		}
	}
	return result;
	}
	
	public String testRequestElementMessageIdSequenceNumAttributeGroupExpireTimeAndGroupMaxIdleDuration
					(String result, String s, int counterGroupExpireTime, int counterGroupMaxIdleDuration) {
	if ( counterGroupExpireTime > 1) {
		result = "InvalidMessageParameters -- Have more than one " +
				"'SequenceNum@groupExpiryTime' Attribute";
	}
	if ( counterGroupMaxIdleDuration > 1) {
		result = "InvalidMessageParameters -- Have more than one " +
				"'SequenceNum@groupMaxIdleDuration' Attribute";
	}
	if ( ( 1 == counterGroupExpireTime ) && ( 1 == counterGroupMaxIdleDuration ) ) {
		result = "InvalidMessageParameters -- " +
				"Have parameter 'SequenceNum@groupExpiryTime' and " +
				"'SequenceNum@groupMaxIdleDuration' at the same time";
	}
	if ( ( counterGroupExpireTime < 1 ) && ( counterGroupMaxIdleDuration < 1 ) ) {
		result = "InvalidMessageParameters -- " +
				"Have neither parameter 'SequenceNum@groupExpiryTime' " +
				"nor 'SequenceNum@groupMaxIdleDuration'";
	}
	result = testRequestElementMessageIdSequenceNumAttributeGroupExpireTimeAndGroupMaxIdleDurationFormat
			(result, s);
	return result;
	}
	
	public String testRequestElementMessageIdSequenceNumAttributeGroupExpireTimeAndGroupMaxIdleDurationFormat
					(String result, String s) {
	if ( "Right".equals(result) ) {
				String sGroupExpiryTime = this.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
			"\\Request\\MessageId\\SequenceNum", "groupExpiryTime");
		if ( sGroupExpiryTime != null ) {
			SimpleDateFormat SDF = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss-HH:mm");
								    try {
		    			    	SDF.parse(sGroupExpiryTime);
		    }  catch (ParseException ex) {
		    			    	result = "InvalidMessageParameters -- the Format of the 'groupExpiryTime' illegally";
		    }
		    
		} else {
						String sGroupMaxIdleDuration = this.getIMessageContext().getRequestServices().selector("Envelope" +
					"\\Header\\Request\\MessageId\\SequenceNum", "groupMaxIdleDuration");
						try {
								Integer.parseInt(sGroupMaxIdleDuration);
			} catch ( NumberFormatException ex) {
								result = "InvalidMessageParameters -- the Format of the 'groupMaxIdleDuration' illegally";
			}
		}
	}
	return result;
	}
	
	public String testRequestElementMessageIdSequenceNumAttributeLast(String result, int conterLast) {
	if ( conterLast > 1 ) {
		result = "InvalidMessageParameters -- Have more than one SequenceNum@last Attribute";
	}
	else {			
	}
	return result;
	}
	
	public String testRequestElementMessageIdSequenceNumAttributeNumber(String result, int counterNumber) {
	if ( counterNumber > 1 ) {
		result = "InvalidMessageId -- Have more than one SequenceNum@number Attribute";
	} else if ( counterNumber < 1 ) {
		result = "InvalidMessageId -- Have no SequenceNum@number Attribute";
	} else {
		
		String sNumber = this.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
				"\\Request\\MessageId\\SequenceNum", "number");
		this.number = WSRMUtil.stringParseLong(sNumber);
	}
	return result;
	}
	
	public String testRequestElementMessageIdSequenceNumAttributeGroupExpireTimeAndGroupMaxIdleDuration
					(String result, int counterGroupExpireTime, int counterGroupMaxIdleDuration) {
	if ( counterGroupExpireTime > 1) {
		result = "InvalidMessageParameters -- Have more than one " +
				"'SequenceNum@groupExpiryTime' Attribute";
	}
	if ( counterGroupMaxIdleDuration > 1) {
		result = "InvalidMessageParameters -- Have more than one " +
				"'SequenceNum@groupMaxIdleDuration' Attribute";
	}
	if ( ( 1 == counterGroupExpireTime ) && ( 1 == counterGroupMaxIdleDuration ) ) {
		result = "InvalidMessageParameters -- " +
				"Have parameter 'SequenceNum@groupExpiryTime' and " +
				"'SequenceNum@groupMaxIdleDuration' at the same time";
	}
	if ( ( counterGroupExpireTime < 1 ) && ( counterGroupMaxIdleDuration < 1 ) ) {
		result = "InvalidMessageParameters -- " +
				"Have neither parameter 'SequenceNum@groupExpiryTime' " +
				"nor 'SequenceNum@groupMaxIdleDuration'";
	}
	return result;
	}
	
	
	public String testRequestElementAckRequested(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\AckRequested");
	if ( test == null ) {
		return result;
	} else {
		if ( test.getChilds().size() > 1 ) {
			result = "InvalidRequest -- Have more than one AckRequested Element";
		} else if ( 1 == test.getChilds().size() ) {
			this.GuaranteedDelivery = true;
		} else { 		}
	}
	return result;
	}
	
	
	public String testRequestElementDuplicateElimination(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\DuplicateElimination");
	if ( test == null ) {
		return result;
	} else {
		if ( test.getChilds().size() > 1 ) {
			result = "InvalidRequest -- Have more than one DuplicateElimination Element";
		} else if ( 1 == test.getChilds().size() ) {
			this.NoDuplicateDelivery  = true;
		} else { 		}
	}
	return result;
	}
	
	
	public String testRequestElementMessageOrder(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\Request\\MessageOrder");
	if ( test == null ) {
		return result;
	} else {
		if ( test.getChilds().size() > 1 ) {
			result = "InvalidRequest -- Have more than one MessageOrder Element";
		} else if ( 1 == test.getChilds().size() ) {
			this.OrderedDelivery  = true;
		} else {
					}
	}
	return result;
	}
	
	
	public String testRequestElementRMAgreementType(String result) {
	
	if ( !this.GuaranteedDelivery && !this.NoDuplicateDelivery && !this.ExactlOnceDelivery ) {
		result = "Invalid RM Agreement: no RM Agreement";
	}
	if ( this.GuaranteedDelivery  && this.NoDuplicateDelivery ) {
		this.ExactlOnceDelivery = true;
	}
	if ( this.OrderedDelivery && ! this.GuaranteedDelivery ) {
		result = "Invalid RM Agreement: when MessageOrder is true, AckRequested must be true";
	}
	if ( this.OrderedDelivery && ! this.NoDuplicateDelivery ) {
		result = "Invalid RM Agreement: when MessageOrder is true, DuplicateElimination must be true";
	}
	return result;
	}
	
	
	public String testRequestElementSoapmustUnderstand(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header\\Request");
	List list = ( (Metaset)test.getChilds().get(0) ).getAttributes();
	String s = null;
	int counter = 0;
	for ( int i = 0 ; i < list.size() ; i ++ ) {
		s = ((Attribute)list.get(i)).getName();
		if ( "mustUnderstand".equals(s) ) {
			counter ++ ;
		}
	}
	if ( counter > 1 ) {
		result = "InvalidRequest -- Have more than one soap:mustUnderstand Attribute";
	} else if ( counter < 1 ) {
		result = "InvalidRequest -- Have no soap:mustUnderstand Attribute";
	} else {
		String value = this.getIMessageContext().getRequestServices().selector("Envelope" +
				"\\Header\\Request", "mustUnderstand");
		if ( !"1".equals(value) ){
			result = "InvalidRequest -- soap:mustUnderstand Attribute value is not 1(true)";
		}
	}
	return result;
	}
	
		
	public String testPollRequestElement() {		String result = "Right";
	result = testPollRequestElementSoapmustUnderstand(result);
	if ( "Right".equals(result) ) {
		result = testPollRequestElementRefToMessageIds(result);				if ( "Right".equals(result) ) {
			result = testPollRequestElementMessageId(result);
			if ( "Right".equals(result) ) {
				result = testPollRequestElementReplyTo(result);
			}
		}
	}
	return result;
	}
	
	
	public String testPollRequestElementSoapmustUnderstand(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header\\PollRequest");
	List list = test.getAttributes();
	String s = null;
	int counter = 0;
	for ( int i = 0 ; i < list.size() ; i ++ ) {
		s = ((Attribute)list.get(i)).getName();
		if ( "mustUnderstand".equals(s) ) {
			counter ++ ;
		}
	}
	if ( counter > 1 ) {
		result = "InvalidPollRequest -- Have more than one soap:mustUnderstand Attribute";
	} else if ( counter < 1 ) {
		result = "InvalidPollRequest -- Have no soap:mustUnderstand Attribute";
	} else {
		String value = this.getIMessageContext().getRequestServices().selector("Envelope" +
				"\\Header\\PollRequest", "mustUnderstand");
		if ( 1 != WSRMUtil.stringParseInteger(value) ){
			result = "InvalidPollRequest -- soap:mustUnderstand Attribute value is not 1(true)";
		}
	}
	return result;
	}
	
	
	public String testPollRequestElementRefToMessageIds(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\PollRequest\\RefToMessageIds");
	if ( 0 == test.getChilds().size() ) {
		result = "InvalidPollRequest -- Have no RefToMessageIds Element";
	}
	return result;
	}
	
	
	public String testPollRequestElementMessageId(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\PollRequest\\RefToMessageIds");
	List list = test.getAttributes();
	if ( list.size() > 1 ) {
		result = "InvalidMessageId -- Have more than one groupID Attribute";
	} else if ( list.size() < 1 ) {
		result = "InvalidMessageId -- Have no groupID Attribute";
	} else {
		result = testPollRequestElementMessageIdSequenceNumRange(result);
	}
	return result;
	}
	
	public String testPollRequestElementMessageIdSequenceNumRange(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\PollRequest\\RefToMessageIds\\SequenceNumRange");;
	
	if ( test != null ) {
		result = testPollRequestElementMessageIdSequenceNumRangeFromTo(result, test);
	}
	return result;
	}
	
	public String testPollRequestElementMessageIdSequenceNumRangeFromTo(String result, Metaset test) {
	List list = test.getAttributes();
	String s = null;
	int counterFrom = 0, counterTo = 0;
	for ( int i = 0 ; i < list.size() ; i ++ ) {
		s = ((Attribute)list.get(i)).getName();
		if ( "from".equals(s) ) {
			counterFrom ++ ;
		}
		if ( "to".equals(s) ) {
			counterTo ++;
		}
	}
	result = testPollRequestElementMessageIdSequenceNumRangeFrom(result, counterFrom);
	if ( "Right".equals(result) ) {
		result = testPollRequestElementMessageIdSequenceNumRangeTo(result, counterTo);
	}
	return result;
	}
	
	public String testPollRequestElementMessageIdSequenceNumRangeTo(String result, int counterTo) {
	if ( counterTo > 1 ) {
		result = "InvalidMessageId -- Have more than one 'to' Attribute";
	} else if ( counterTo < 1 ) {
		result = "InvalidMessageId -- Have no 'to' Attribute";
	} else {
		 
	}
	return result;
	}
	
	public String testPollRequestElementMessageIdSequenceNumRangeFrom(String result, int counterFrom) {
	if ( counterFrom > 1) {
		result = "InvalidMessageId -- Have more than one 'from' Attribute";
	} else if ( counterFrom < 1 ) {
		result = "InvalidMessageId -- Have no 'from' Attribute";
	} else {
		
	}
	return result;
	}
	
	
	public String testPollRequestElementReplyTo(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
		"\\PollRequest\\ReplyTo");
	if ( test != null ) {			test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
			"\\PollRequest\\ReplyTo\\BareURI");
		if ( test.getChilds().size() > 1 ) {
			result = "InvalidReplyPattern -- Have more than one 'BareURI' Element";
		}
		else {
			test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
				"\\PollRequest\\ReplyTo");
			List list = ( (Metaset)test.getChilds().get(0) ).getAttributes();
			String sRC = null;
			int counter = 0;
			for ( int i = 0 ; i < list.size() ; i ++ ) {
				sRC = ((Attribute)list.get(i)).getName();
				if ( "reference-scheme".equals(sRC) ) {
					counter ++ ;
				}
			}
			if ( 0 == test.getChilds().size() ) {
				if ( counter > 1 ) {
					result = "InvalidReplyPattern -- Have more than one 'reference-scheme' Attribute";
				}
				else if ( counter < 1 ) {
					result = "InvalidReplyPattern -- Have no 'reference-scheme' Attribute";
				}
				else {					}
			}
			else {
				if ( counter >= 1 ) {
					result = "InvalidReplyPattern -- " +
							"'reference-scheme' Attribute can not occur when element 'BareURI' occur";
				}
				else {					}
			}
		}
	}
	else {		}
	return result;
	}
	
	 
	
	
	public String testResponseElement() {		String result = "Right";
	result = testResponseElementSoapmustUnderstand(result);
	return result;
	}
	
	
	public String testResponseElementSoapmustUnderstand(String result) {
	Metaset test = this.getIMessageContext().getRequestServices().filter("Envelope\\Header\\Response");
	List list = ( (Metaset) test.getChilds().get(0) ).getAttributes();
	String s = null;
	int counter = 0;
	for ( int i = 0 ; i < list.size() ; i ++ ) {
		s = ((Attribute)list.get(i)).getName();
		if ( "mustUnderstand".equals(s) ) {
			counter ++ ;
		}
	}
	if ( counter > 1 ) {
		result = "InvalidResponse -- Have more than one soap:mustUnderstand Attribute";
	} else if ( counter < 1 ) {
		result = "InvalidResponse -- Have no soap:mustUnderstand Attribute";
	} else {
		String value = this.getIMessageContext().getRequestServices().selector("Envelope" +
				"\\Header\\Response", "mustUnderstand");
		if ( 1 != WSRMUtil.stringParseInteger(value) ){
			result = "InvalidResponse -- soap:mustUnderstand Attribute value is not 1(true)";
		}
	}
	return result;
	}
	
}
