package org.act.services.protocol.wsdd;
import java.util.Hashtable;
import java.util.Vector;
import org.act.services.ConfigException;
import org.act.services.ServicesObject;
import org.act.services.pool.IObjectPool;
import org.act.services.protocol.ProviderProtocol;
import org.act.services.provider.ProviderException;
import org.act.services.provider.ServerImplementException;
import org.act.services.runtime.Application;
import org.act.services.thread.ObjectOperationException;
import org.act.services.thread.ObjectProducerThreadPoolRunnable;
import org.act.services.transaction.information.RunningData;
import org.act.services.transaction.information.TxSetting;
import org.act.services.transaction.manager.TxStatus;
import org.act.services.transaction.messages.Context;
import org.act.services.transaction.messages.ContextReply;
import org.act.services.transaction.messages.Message;
import org.act.services.transaction.participant.Participant;
import org.act.services.transaction.util.BTPUtil;
import org.act.services.transaction.util.MessageUtil;
import org.act.services.wsdd.DeployContext;
import org.act.services.wsdl.model.ServicesMethod;
import org.act.metaset.Metaset;

public class WSDDProviderProtocol extends ProviderProtocol {
	public WSDDProviderProtocol() {
		super();
	}
	public Object adapt(Object obj) {
		if (obj instanceof ServicesObject) {
			return new ServicesObjectProcessor((ServicesObject) obj);
		}
		return null;
	}
	public void config(Metaset config) throws ConfigException {
		super.config(config);
	}
	public void start() {
				
	}
	public void stop() {
				
	}
}

class ServicesObjectProcessor implements ObjectProducerThreadPoolRunnable {
	private ServicesObject servicesObject;
	private IObjectPool providerResponsePool;
	public ServicesObjectProcessor(
		ServicesObject servicesObject) {
		this.servicesObject = servicesObject;
	}
	
		public void process(ServicesObject obj) throws ObjectOperationException {
		
		ClassLoader old = Thread.currentThread().getContextClassLoader();			
		DeployContext context = obj.getServiceContext().getDeployContext();
		Thread.currentThread().setContextClassLoader(context.getClassLoader());
		try {
			try {
								Metaset head_s=(Metaset)obj.getRequestServices().getChilds().get(0);
								Metaset tx_s=head_s.filter(".\\context");
								Metaset ctp_s=null;
								Metaset btpreturn_s=null;
								Metaset btpm_s=head_s.filter(".\\message");
								if(btpm_s!=null){
									String btp_m=(btpm_s.car()).car().toXML().toString();
				
																Metaset txid_s=head_s.filter(".\\TransactionID");
								
				if(txid_s!=null){
					String txid=txid_s.car().getValue();
					String sName=servicesObject.getServiceContext().getWebServiceName();
					
					Hashtable service=(Hashtable)RunningData.getServiceTab(txid);
					Participant tx_parpant=null;
					synchronized(service){
					 tx_parpant=(Participant)service.get(sName);
					}
										try{
						Message msg=MessageUtil.parseMessage(btp_m);
						int msgtype=msg.getType();
						if(msgtype==Message.TYPE_ENROLLED){
							synchronized(tx_parpant){
							tx_parpant.SetEnrollResponse(msg);
														tx_parpant.notifyAll();
							}
						}
					}catch(Exception e){
						e.printStackTrace();
					}
					
					String return_m=tx_parpant.onMessage(btp_m);
										btpreturn_s=BTPUtil.toServicesSet(return_m);
					                    try{
                    	instanceManager(txid,tx_parpant);
                    }catch(Exception ex){
                    	ex.printStackTrace();
                    }
					
				}
				}
								else{ 
				if(tx_s!=null)
				{
				try{
				Context ctx=(Context)MessageUtil.parseMessage(tx_s.toXML().toString());
				String txId=ctx.getTransactionId();
								Participant participant=new Participant();
			
								ServicesMethod Smth=(ServicesMethod)obj.getServiceContext().getMethods().get(0);
				Class cls=Smth.getImplementationClass();
				participant.SetWsClass(cls);
								 if (txId == null){
				 	throw new Exception("context in application soap header"+"does not container transactionId");
				 }
				 else{
				 			 
				 	try{
				 		instanceManager(txId,participant);
				 						 		ContextReply ctp=(ContextReply)participant.onContext(ctx);
												 
						ctp_s=ctp.toServiceSet();
                        
				 	}catch(Exception e){
				 		e.printStackTrace();
				 	}
				 }				 
				}catch(Exception e){
					e.printStackTrace();
				}
				
				}
                				}
				
												obj.getServiceContext().getDeployContext().getProvider().process(obj);
				Metaset ss = obj.getRequestServices().filter(".\\Header");
				if (ss!=null) {
					if (Application.isDebug()) {
					System.out.println("ServicesObjectProcessor.process()");
					}
															if(ctp_s!=null){
												Metaset headp_s=ss.car();
						ss.remove(headp_s);
												Metaset ctxq_s=headp_s.filter(".\\context");
						headp_s.remove(ctxq_s.car());
						headp_s.add("Header\\",ctp_s);
												ss.add(headp_s);
					}
																				if(btpreturn_s!=null){
                        						Metaset head_btp=ss.car();
						ss.remove(head_btp);
												Metaset btpmre=head_btp.filter(".\\message");
						Metaset btpmsg=btpmre.car();
						head_btp.remove(btpmsg);
												btpmsg.remove(btpmsg.car());
												btpmsg.add(btpreturn_s);
						head_btp.add(btpmsg);
						ss.add(head_btp);
						
					}
					obj.getMessageContext().getResponseServices().getChilds().set(0,ss.car());
				}
				
			} catch (ServerImplementException e1) {
				e1.printStackTrace();
			}
		} catch (ProviderException e) {
			e.printStackTrace();
		}
		finally {
			Thread.currentThread().setContextClassLoader(old);
		}
	}
	public void setReceiver(IObjectPool receiver) {
		this.providerResponsePool = receiver;	
	}
	public Object[] getInitData() {
		return null;
	}
	public void runIt(Object[] thData) {
		try {
			process(servicesObject);
		} catch (ObjectOperationException e) {
			e.printStackTrace();
		}
		synchronized (providerResponsePool) {
			while (providerResponsePool.full()) {
				try {
					providerResponsePool.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			providerResponsePool.put(servicesObject);
			providerResponsePool.notifyAll();
		}
	}
	public void instanceManager(String id,Participant participant)throws Exception{
          	      String txIdCopy = new String(id);
	      	      	      int maxCount = TxSetting.getTxMaxCount();
	      Vector txList = RunningData.getTxIdList();
	      
	      	      for (int i = 0; i < txList.size(); i++)
	      {
	          String txId_ = (String)txList.get(i);
	          String status = RunningData.getTxStatus(txId_);
	          if (status == TxStatus.TX_CONFIRMED
	              || status == TxStatus.TX_CANCELLED
	              || status == TxStatus.TX_FAULT)
	          {
	              	              RunningData.removeTX_STATUS(txId_);
	              	              RunningData.removeServiceObj(txId_);
	          }
	      }
	      	      if (RunningData.getRunningTxNumber() > maxCount)
	      {
	          	          RunningData.setTxStatus(txIdCopy, TxStatus.TX_FAULT);
	          throw new Exception("the running transaction instances has"
	                                + " reached the max number " + maxCount);
	      }
	      	      Hashtable services = (Hashtable)RunningData.getServiceTab(txIdCopy);
	      String serviceName=servicesObject.getServiceContext().getWebServiceName();
	      	      participant.setServiceName(serviceName);
	      	      if (services == null)
	      {
	          services = new Hashtable();
	          	          services.put(serviceName, participant);
              RunningData.putServiceTab(txIdCopy, services);
	      }
	      else{
	      	services.put(serviceName, participant);
	      	RunningData.putServiceTab(txIdCopy, services);
	      }
	      
	   
	}
}
