
package org.act.services.provider;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;
import org.act.metaset.Metaset;
import org.act.services.IMessageContext;
import org.act.services.ServicesObject;
import org.act.services.wsdl.model.ServicesMethod;

public class JavaProvider extends Provider {
		
	
	
	protected void doRPCProcess(ServicesObject object)
		throws ProviderException {
		try {
			Method method = getMethod(object.getServicesMethod());
			Metaset msg =
				(Metaset) method.invoke(
			getInstance(object.getServicesMethod().getImplementationClass()),
					new Object[] { object.getRequestServices()});
			object.setResponseServices(msg);
		} catch (Exception ex) {
			throw new ProviderException(ex);
		}
	}
	
			private Map cachedMethods = new HashMap();
	
		
	private Method getMethod(ServicesMethod sm) throws SecurityException,NoSuchMethodException {
		Method method = (Method) cachedMethods.get(sm);
		if (method==null) {
			Class cls = sm.getImplementationClass();
			method = cls.getMethod(sm.getName(),new Class[]{Metaset.class});
			cachedMethods.put(sm, method);
		}
		return method;
	}
	
		private Object instance = null;
	private Object getInstance(Class cls) throws Exception {
		if (instance==null) {
			instance = cls.newInstance();
		}
		return instance;
	}
	
	protected void doDocumentProcess(ServicesObject object) throws ProviderException, ServerImplementException {
		IMessageContext mc = object.getMessageContext();
		try {
			Method method = getDocumentMethod(object.getServicesMethod());
										method.invoke(
			getInstance(object.getServicesMethod().getImplementationClass()),
					new Object[] { object.getMessageContext()});
		} catch (SecurityException e) {
						e.printStackTrace();
		} catch (IllegalArgumentException e) {
						e.printStackTrace();
		} catch (NoSuchMethodException e) {
						e.printStackTrace();
		} catch (IllegalAccessException e) {
						e.printStackTrace();
		} catch (InvocationTargetException e) {
						e.printStackTrace();
		} catch (Exception e) {
						e.printStackTrace();
		}
					}
	
	private Method getDocumentMethod(ServicesMethod sm) throws SecurityException,NoSuchMethodException {
		Method method = (Method) cachedMethods.get(sm);
		if (method==null) {
			Class cls = sm.getImplementationClass();
			method = cls.getMethod(sm.getName(),new Class[]{IMessageContext.class});
			cachedMethods.put(sm, method);
		}
		return method;
	}
}
