
package org.act.services.provider;
import org.act.services.ServicesObject;
import org.act.services.wsdl.model.ServicesMethod;

public abstract class Provider {
	
	public void process (ServicesObject object)
		throws ProviderException, ServerImplementException {
		int processStyle = object.getServicesMethod().getProcessStyle();
		if (processStyle==ServicesMethod.RPC) {
			doRPCProcess(object);
		}
		else if (processStyle==ServicesMethod.DOCUMENT) {
			doDocumentProcess(object);
		}
	}
	
	protected abstract void doRPCProcess (ServicesObject object)
	throws ProviderException, ServerImplementException;
	
	protected abstract void doDocumentProcess (ServicesObject object)
	throws ProviderException, ServerImplementException;
	
	}
