
package org.act.services.wsdl.model;
import java.util.ArrayList;
import java.util.List;
import org.act.metaset.Metaset;
import org.act.services.wsdd.DeployContext;
import org.act.wsrf.resourceproperties.Resource;
import org.act.wsrf.resourceproperties.ResourceContext;

public class ServicesContext {
	private String webServicesName = null;
	private List methods = null;
	private DeployContext deployContext = null;
	private boolean enabled = true;
		private ResourceContext resourceContext;
	private Resource resource;
	
	public ServicesContext(String name) {
		this.webServicesName = name;
	}
	
	public List getMethods() {
		if (methods==null) {
			methods = new ArrayList();
		}
		return methods;
	}
	
	
	public String getWebServiceName() {
		return webServicesName;
	}
	
	public ServicesMethod getMethod(Metaset set) throws NoSuchServicesMethodException {
						Metaset childElements = set.filter(".\\Body\\*");
		if (!childElements.isEmpty()) {
			Metaset firstChildElement = childElements.car();
			String name = firstChildElement.getName();
			for (int i=0; i<getMethods().size(); i++) {
				ServicesMethod method = (ServicesMethod) getMethods().get(i);
				if (method.getName().equals(name) && firstChildElement.getChilds().size()==method.getParameters().size()) {
					return method;
				}
			}
		}
		return null;
	}
	
	
	public DeployContext getDeployContext() {
		return deployContext;
	}
	
	public void setDeployContext(DeployContext deployContext) {
		this.deployContext = deployContext;
	}
	
		public ResourceContext getResourceContext(){
		return resourceContext;
	}
	
	public void setResourceContext(ResourceContext resourceContext){
		this.resourceContext = resourceContext;
	}
	
	public void setResource(Resource resource){
		this.resource = resource;
	}
	
	public Resource getResource(){
		return resource;
	}
	
	public boolean isEnabled() {
		return enabled;
	}
	
	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
	}
	
	public void setWebServiceName(String webServicesName) {
		this.webServicesName = webServicesName;
	}
}
