package org.act.ws.provider;
import org.act.metaset.Metaset;
import org.act.services.IMessageContext;
import org.act.services.ServicesObject;
import org.act.services.pool.IObjectPool;
import org.act.services.provider.ProviderException;
import org.act.services.provider.ServerImplementException;
import org.act.services.thread.ObjectOperationException;
import org.act.services.thread.ThreadPoolRunnable;
import org.act.services.wsdl.model.IServicesContextPool;
import org.act.services.wsdl.model.NoSuchServicesMethodException;
import org.act.services.wsdl.model.ServicesContext;
import org.act.services.wsdl.model.ServicesMethod;
public class SimpleProvider implements ThreadPoolRunnable {
	private IMessageContext msgContext;
	private IObjectPool mco;
	private static ServicesContext admin = null;
	public SimpleProvider(IMessageContext msgContext, IObjectPool pool) {
		this.msgContext = msgContext;
		this.mco = pool;
		admin = IServicesContextPool.INSTANCE.getServices()[0];
	}
	
	public Object[] getInitData() {
		return null;
	}
	
	public void process(ServicesObject obj) throws ObjectOperationException {
		try {
			try {
				obj.getServiceContext().getDeployContext().getProvider().process(obj);
				Metaset ss = obj.getRequestServices().filter(".\\Header");
				if (ss!=null) {
					obj.getMessageContext().getResponseServices().getChilds().set(0,ss.car());
				}
			} catch (ServerImplementException e1) {
				e1.printStackTrace();
			}
		} catch (ProviderException e) {
			e.printStackTrace();
		}
	}
	
	public void runIt(Object[] thData) {
			try {
				ServicesMethod method = admin.getMethod(msgContext.getRequestServices());
				ServicesObject object = new ServicesObject(admin, msgContext,method);
				process(object);
				synchronized (mco) {
					while (mco.full()) {
						mco.notifyAll();
						try {
							Thread.sleep(1000);
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
					mco.put(object.getMessageContext());
					mco.notifyAll();
				}
			} catch (NoSuchServicesMethodException e) {
				e.printStackTrace();
			} catch (ObjectOperationException e) {
				e.printStackTrace();
			}
	}
}
