package org.act.services.transaction.client;
import java.util.List;
import java.util.Vector;
import org.act.services.transaction.exception.TxException;
import org.act.services.transaction.manager.Decider;
import org.act.services.transaction.manager.DeciderRunningPool;
import org.act.services.transaction.manager.TxControl;
import org.act.services.transaction.messages.Begin;
import org.act.services.transaction.messages.CancelTransaction;
import org.act.services.transaction.messages.ConfirmTransaction;
import org.act.services.transaction.messages.Context;
import org.act.services.transaction.messages.Fault;
import org.act.services.transaction.messages.Message;
import org.act.services.transaction.messages.RelatedGroup;
import org.act.services.transaction.messages.TransactionCancelled;
import org.act.services.transaction.messages.TransactionConfirmed;
import org.act.services.transaction.util.TxUri;
public class UserTransaction {
    
    private String managerUrl_ = null;
    
    private Context txContext_ = null;
    
    private boolean isAtom = true;
    
    private boolean loglast_ = false;
    
    private String lastin_ = null;
    
    private String lastout_ = null;
    
    private String txId_ = null;
    
    private TxControl control_ = null;
    
    private boolean isSubTransaction = false;
    
    private Vector incomeMsgs = null;
    
    private Vector outcomeMsgs = null;
    
    public String transactionName;
    
    private UserTransaction()
    {
                incomeMsgs = new Vector();
        outcomeMsgs = new Vector();
               
    }
    public void setTransactionname(String Tname)
    {
        transactionName=Tname;
    }
        public String getTransactionname()
    {
        return transactionName;
    }
        public boolean isAtom()
    {
        return isAtom;
    }
          public String suprid()
      {
          return this.txContext_.getSuperiorIdentifier();
      }
    
    public static UserTransaction newInstance()
    {
        return new UserTransaction();
    }
    
    private Message sendMessage(String url, Message msg)
        throws TxException
    {
        try
        {
                        lastout_ = msg.toString();
            outcomeMsgs.add(lastout_);
                                    Message reply=null;
                                    lastin_ = reply.toString();
            incomeMsgs.add(lastin_);
            return reply;
        }
        catch (Exception e)
        {
            throw new TxException(null,"occur exception:" + e.getMessage()
                                  + "  when send message to " + url
                                  + " message = " + msg.toString(),null,null,null);
        }
    }
             public void setManagerUrl(String managerUrl)
    {
        this.managerUrl_ = managerUrl;
    }
    
    
    public Context beginAtom()
        throws TxException
    {
        return begin(true);
    }
    
    public Context beginCohesion()
        throws TxException
    {
        return begin(false);
    }
    
    private Context begin(boolean atom)
        throws TxException
    {
        Begin begin = new Begin();
        begin.setAtom(atom);
        if (txId_ == null)
        {
            txId_ = TxUri.buildTxId();
        }
        begin.setTransactionId(txId_);
                   lastout_ = begin.toString();
           outcomeMsgs.add(lastout_);
        if (this.managerUrl_ == null)
        {
            System.err.print("UTЭַΪգ");
        }
               Decider Superior = new Decider();
              Message reply = Superior.onBegin(begin);
      
                DeciderRunningPool.registerDecider(txId_,Superior);
        System.err.println("ǰЭ"+DeciderRunningPool.sizeOfDecider());
        DeciderRunningPool.showTxID();
               
                        lastin_ = reply.toString();
            incomeMsgs.add(lastin_);
                if (reply.getType() == Message.TYPE_RELATED_GROUP)
        {
            if (((RelatedGroup)reply).getBegun() == null)
            {
                throw new TxException(
                    null,"BEGUN message is not in the receiving relatedgroup message",null,null,null);
            }
            else
            {
                this.txContext_ = ((RelatedGroup)reply).getContext();
                txId_ = txContext_.getTransactionId();
                return txContext_;
            }
        }
        else
        {
                        throw new TxException(
                null,"excepion occur in received relatedgroup message of begun and context:"
                + ((Fault)reply).getFaultText(),null,null,null);
        }
    }
    
    public Context begin(Context parentContext)
        throws TxException
    {
        RelatedGroup beginContext = new RelatedGroup();
        Begin begin = new Begin();
        begin.setAtom(true);
        if (this.managerUrl_ == null)
        {
            throw new TxException(null,"sub transaction manager url can not be null!",null,null,null);
        }
        begin.setTargetAddress(this.managerUrl_);
        begin.setTransactionId(parentContext.getTransactionId());
        beginContext.addMessage(parentContext);
        beginContext.addMessage(begin);
        Message reply = sendMessage(this.managerUrl_, beginContext);
                if (reply.getType() == Message.TYPE_RELATED_GROUP)
        {
            if (((RelatedGroup)reply).getBegun() == null)
            {
                throw new TxException(
                    null,"BEGUN message is not in the receiving relatedgroup message",null,null,null);
            }
            else
            {
                                this.txContext_ = ((RelatedGroup)reply).getContext();
                txId_ = txContext_.getTransactionId();
                return txContext_;
            }
        }
        else
        {
                        throw new TxException(
                null,"excepion occur in received relatedgroup message of begun and context:"
                + ((Fault)reply).getFaultText(),null,null,null);
        }
    }
   
    
    public boolean confirmAtomTransaction()
        throws TxException
        , Exception
    {
        if (this.txContext_ == null)
        {
            throw new TxException(
                null,"transaction context is null, the transaction may not begin",null,null,null);
        }
        else if (this.txContext_.isCohesion())
        {
            throw new TxException(
                null,"cohesion transaction can not use confirmAtomTransaction operation",null,null,null);
        }
        else if (this.isSubTransaction)
        {
            throw new TxException(
                null,"you can not commit sub atomic transaction.",null,null,null);
        }
        ConfirmTransaction confirmTx =
            new ConfirmTransaction(this.txContext_.getTransactionId(), true);
        confirmTx.setTransactionId(txId_);
                Decider superior = (Decider)DeciderRunningPool.getDecider(txId_);
      
                            lastout_ = confirmTx.toString();
            outcomeMsgs.add(lastout_);
            String xml=lastout_;
                Message reply = superior.onConfirmTransaction(confirmTx);
        System.err.println("***************************"+txId_+"*****************************") ;
                                          lastin_ = reply.toString();
           incomeMsgs.add(lastin_);
        if (reply instanceof Fault)
        {
            throw new TxException(null,((Fault)reply).getFaultText(),null,null,null);
        }
        if (reply instanceof TransactionConfirmed)
        {
            return true;
        }
        if (reply instanceof TransactionCancelled)
        {
            return false;
        }
        return true;
    }
    
    public boolean cancelTransaction()
        throws TxException
    {
                List dblist;
        if (this.txContext_ == null)
        {
            throw new TxException(
                null,"transaction context is null, the transaction may not begin",null,null,null);
        }
                if (control_ != null && this.isSubTransaction)
        {
            int result = control_.cancel(txId_);
            if (result == TxControl.TX_CANCELLED)
            {
                return true;
            }
            else
            {
                throw new TxException(null,"can not cancel sub transaction:"
                                      + this.txContext_.getSuperiorIdentifier(),null,null,null);
            }
        }
        boolean result = true;
        CancelTransaction cancelTx =
            new CancelTransaction(this.txContext_.getTransactionId(), true);
        cancelTx.setTransactionId(txId_);
                      Decider cancelsuperior=(Decider)DeciderRunningPool.getDecider(txId_);
                         lastout_ = cancelTx.toString();
           outcomeMsgs.add(lastout_);
                Message cancelreply = cancelsuperior.onCancelTransaction(cancelTx);
                                           lastin_ = cancelreply.toString();
           incomeMsgs.add(lastin_);
               if (cancelreply instanceof Fault)
        {
            throw new TxException(null,((Fault)cancelreply).getFaultText(),null,null,null);
        }
        if (cancelreply instanceof TransactionCancelled)
        {
            result = true;
        }
        return result;
    }
    
   
    
    
    

    
    public Context getContext()
    {
        return this.txContext_;
    }
    
    public void setTxControl(TxControl control)
    {
        this.control_ = control;
    }
    
    public String getTransactionId()
    {
        if (this.txContext_ != null)
        {
            return txContext_.getTransactionId();
        }
        return null;
    }
    
    public void setIsSubTransaction(boolean isSubTx)
    {
        this.isSubTransaction = isSubTx;
    }
    
    public void setLogMessage(boolean log)
    {
        loglast_ = log;
    }
    
    public String getLastOutgoing()
    {
        return lastout_;
    }
    
    public String getLastIncoming()
    {
        return lastin_;
    }
    
    public Vector getIncomeMsgs()
    {
        return this.incomeMsgs;
    }
    
    public Vector getOutcomeMsgs()
    {
        return this.outcomeMsgs;
    }
    
    public void setTxContext(Context TxContext)
    {
        this.txContext_ = TxContext;
    }
    
    public void setIsAtom(boolean isatom)
    {
        this.isAtom = isatom;
    }
    
    public void setTransactionID(String TransactionID)
    {
        this.txId_ = TransactionID;
    }
}
