
package org.act.services.transaction.manager;


import java.util.*;
import org.act.services.transaction.messages.*;
import org.apache.log4j.*;
public abstract class Actor {
    
    private Category logger_ = null;
    
    private String webServiceUrl = null;
    private String serviceName = null;
    
	
	public String getServiceName() {
		return serviceName;
	}
	
	public void setServiceName(String serviceName) {
		this.serviceName = serviceName;
	}
    
    int maxlog_ = 3;
    
    Vector lastin_ = null;
    
    Vector lastout_ = null;
    
    protected Actor(Category logger)
    {
        logger_ = logger;
        lastin_ = new Vector();
        lastout_ = new Vector();
    }
    
    public Category logger()
    {
        return logger_;
    }
    
       
    
    protected String getWebServiceUrl()
    {
        if (webServiceUrl == null)
        {
            String address = null;
            try
            {
                java.net.InetAddress net = java.net.InetAddress.getLocalHost();
                address = net.getHostAddress();
            }
            catch (Exception e)
            {
                                address = "127.0.0.1";
            }
                                                            webServiceUrl = "http://" + address + ":9080/" + serviceName;
        }
        return webServiceUrl;
    }
     
    
    public String messages(String xml)
    {
        int pos = xml.toLowerCase().indexOf("act-admin>");
        boolean isadmin = (pos > 0 && pos < xml.indexOf(">"));
                if (!isadmin)
        {
            logIncoming(xml);
        }
                String ret = onMessage(xml);
                if (!isadmin)
        {
            logOutgoing(ret);
        }
        return ret;
    }
    
    protected void logOutgoing(String xml)
    {
        String latest = xml;
        if (lastout_.size() >= maxlog_)
        {
            lastout_.remove(lastout_.size() - 1);
        }
        lastout_.insertElementAt(latest, 0);
    }
    
    public void logOutgoing(Message m)
    {
        logOutgoing(m.toString());
    }
    
    protected void logIncoming(String xml)
    {
        String latest = xml;
        if (lastin_.size() >= maxlog_)
        {
            lastin_.remove(lastin_.size() - 1);
        }
        lastin_.insertElementAt(latest, 0);
    }
    
    public void logIncoming(Message m)
    {
        logIncoming(m.toString());
    }
    
    public abstract String onMessage(String xml);
    
    public String getLastIncoming()
    {
        if (lastin_ == null || lastin_.size() <= 0)
        {
            return null;
        }
        return lastin_.elementAt(0).toString();
    }
    
    public String getLastOutgoing()
    {
        if (lastout_ == null || lastout_.size() <= 0)
        {
            return null;
        }
        return lastout_.elementAt(0).toString();
    }
    
    public String getLastIncoming(int pos)
    {
        if (lastin_ == null || lastin_.size() <= pos)
        {
            return null;
        }
        return lastin_.elementAt(pos).toString();
    }
    
    public String getLastOutgoing(int pos)
    {
        if (lastout_ == null || lastout_.size() <= pos)
        {
            return null;
        }
        return lastout_.elementAt(pos).toString();
    }
    
    public Vector getRecentIncoming()
    {
        return lastin_;
    }
    
    public Vector getRecentOutgoing()
    {
        return lastout_;
    }
    
    public void setMaxlog(int maxlog)
    {
        this.maxlog_ = maxlog;
    }
    
    public void setWebServiceUrl(String WSAddr_)
    {
        this.webServiceUrl = WSAddr_;
    }
}
