
package org.act.services.transaction.manager;


import java.sql.SQLException;
import org.act.services.transaction.information.*;
import org.act.services.transaction.messages.*;
import org.act.services.transaction.participant.*;
import org.act.services.transaction.util.*;
import org.apache.log4j.Category;
import org.act.services.workflow.transaction.InferiorRecord;
import org.act.services.workflow.transaction.MessageProxy;
import org.act.services.workflow.transaction.TransactionDB;
public class InferiorResource {
	
    private String address_ = null;
    
    private Actor from_ = null;
    
    private Category logger = null;
    
    private String status = Status.STATUS_UNKNOWN;
    
    private String superId = null;
    
    private String inferId = null;
    
    private String txId = null;
    
    private String compensationAddress = null;
    
        private String ReturnMsg=null;
            private long preparetime_b=0;
    private long preparetime_e=0;
    private long confirmtime_b=0;
    private long confirmtime_e=0;
    private long canceltime_b=0;
    private long canceltime_e=0;
        
    
        InferiorRecord inferiorrecord=new InferiorRecord(txId);
        
    public InferiorResource()
    {
        logger = LogCategory.getCategory("");
    }
    
    public InferiorResource(Enrol enrol, Actor from)
    {
        this.from_ = from;
        logger = LogCategory.getCategory("");
        txId = enrol.getTransactionId();
                inferiorrecord.setTxid(txId);
                superId = enrol.getSuperiorIdentifier();
        inferId = enrol.getInferiorIdentifier();
        inferiorrecord.setInferiorId(inferId);
                Address add = enrol.getInferiorAddress(0);
        status = Status.STATUS_ACTIVE;
        inferiorrecord.setStatus(status);
                compensationAddress = enrol.getCompensationAddress();
        if (add == null)
        {
            logger.debug("enrolϢвinferiorĵַ, infer ID:" + inferId);
        }
        else
        {
            address_ = add.getAddress();
        }
    }
    
    public void setSatus(String status)
    {
        this.status = status;
    }
    
    public String getSatus()
    {
        return this.status;
    }
    
    public String getTransactionId()
    {
        return this.txId;
    }
    
    public void setTransactionId(String txId_)
    {
        this.txId = txId_;
    }
    
    public String getInferiorId()
    {
        return this.inferId;
    }
    
    public void setInferiorId(String iferId_)
    {
        this.inferId = iferId_;
    }
    
    public String getInfeirorAddress()
    {
        return this.address_;
    }
    
    public void setInfeirorAddress(String InfeirorAddress)
    {
        this.address_ = InfeirorAddress;
    }
    
    public String getSuperiorId()
    {
        return this.superId;
    }
    
    public void setSuperiorId(String superId_)
    {
        this.superId = superId_;
    }
    
    public String getCompensationAddr()
    {
        return this.compensationAddress;
    }
    
    public void setCompensationAddr(String compensationAddress_)
    {
        this.compensationAddress = compensationAddress_;
    }
    
    public Actor getActor()
    {
        return this.from_;
    }
    
    public void setActor(Actor actor)
    {
        this.from_ = actor;
    }
    
    public synchronized int prepare(String transactionid)
    {
        int ret = Vote.VOTE_FAULT;
        status = Status.STATUS_PREPARING;
        inferiorrecord.setStatus(status);
        DBLog.logInfeirorStatus(this);
        Prepare prepare = new Prepare();
        prepare.setInferiorIdentifier(inferId);
        prepare.setTransactionId(txId);
        Message retMsg = null;
        try
        {
            logger.debug("ʼַ:" + address_ + "prepareϢ");
            preparetime_b=System.currentTimeMillis();
            inferiorrecord.setPreparetime_b(preparetime_b);
                        retMsg=MessageProxy.sendMessage(address_, prepare,txId);
                        	            	preparetime_e=System.currentTimeMillis();
            	inferiorrecord.setPreparetime_e(preparetime_e);
            	            	from_.logIncoming(prepare);
                from_.logOutgoing(retMsg);
                   }
        catch (Exception e)
        {
            logger.debug("prepreϢõӦʱ쳣" + e.getMessage());
            status = Status.STATUS_FAULT;
            DBLog.logInfeirorStatus(this);
        }
        if (retMsg != null)
        {
                        switch (retMsg.getType())
            {
                case Message.TYPE_FAULT:
                    status = Status.STATUS_FAULT;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    ret = Vote.VOTE_FAULT;
                    logger.debug("[" + inferId + "]prepreִ:" +
                                 ((Fault)retMsg).getFaultText());
                    break;
                case Message.TYPE_PREPARED:
                    status = Status.STATUS_PREPARED;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    ret = Vote.VOTE_PREPARED;
                    logger.debug("[" + inferId + "] prepreͶƱ޳");
                    break;
                case Message.TYPE_CANCELLED:
                    status = Status.STATUS_ABORTED;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    ret = Vote.VOTE_ABORTED;
                    logger.debug("[" + inferId + "] prepreͶƱ");
                    break;
                case Message.TYPE_RESIGN:
                    status = Status.STATUS_RESIGNED;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    ret = Vote.VOTE_RESIGN;
                    logger.debug("[" + inferId + "]prepreȡǼϢ");
                    break;
                default:
                    ret = Vote.VOTE_FAULT;
                    status = Status.STATUS_FAULT;
            }
        }
        return ret;
    }
    
    public synchronized boolean cancel(String transactionid)
    {
        boolean result = false;
        status = Status.STATUS_CANCELLING;
        inferiorrecord.setStatus(status);
        DBLog.logInfeirorStatus(this);
        Cancel cancel = new Cancel();
        cancel.setInferiorIdentifier(inferId);
        cancel.setTransactionId(txId);
        Message retMsg = null;
        try
        {
            logger.debug("ʼַ:" + address_ + "cancelϢ");
                         canceltime_b=System.currentTimeMillis();
            inferiorrecord.setCanceltime_b(canceltime_b);
            retMsg= MessageProxy.sendMessage(address_, cancel,txId);
           
            	            	canceltime_e=System.currentTimeMillis();
            	inferiorrecord.setCanceltime_e(canceltime_e);
            	retMsg=MessageUtil.parseMessage(ReturnMsg);
            	from_.logIncoming(cancel);
                from_.logOutgoing(retMsg);
                  }
        catch (Exception e)
        {
            logger.debug("cancelϢõӦʱ쳣" + e.getMessage());
            status = Status.STATUS_FAULT;
            DBLog.logInfeirorStatus(this);
        }
        if (retMsg != null)
        {
            switch (retMsg.getType())
            {
                case Message.TYPE_CANCELLED:
                    status = Status.STATUS_CANCELLED;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId + "] ִCancel");
                    result = true;
                    break;
                case Message.TYPE_CONFIRMED:
                    status = Status.STATUS_CONFIRMED;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "]ִcancelconfirmedϢ");
                    break;
                case Message.TYPE_FAULT:
                    status = Status.STATUS_FAULT;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "] cancelִ:" +
                                 ((Fault)retMsg).getFaultText());
                    break;
                case Message.TYPE_HAZARD:
                    status = Status.STATUS_FAULT;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "]cancelִܵHazardϢ:" +
                                 ((Hazard)retMsg).geHazardInfo());
                    break;
                default:
            }
        }
        try {
			TransactionDB.inferiorRecord2DB(inferiorrecord);
		} catch (SQLException e) {
						e.printStackTrace();
		}
        return result;
    }
    
    public synchronized boolean confirm(String transactionid)
    {
        boolean result = false;
        status = Status.STATUS_CONFIRMING;
        inferiorrecord.setStatus(status);
        DBLog.logInfeirorStatus(this);
        Confirm confirm = new Confirm();
        confirm.setInferiorIdentifier(inferId);
        confirm.setTransactionId(txId);
        Message retMsg = null;
        try
        {
            logger.debug("ʼַ:" + address_ + "confirmϢ");
                        confirmtime_b=System.currentTimeMillis();
            inferiorrecord.setConfirmtime_b(confirmtime_b);
            retMsg=MessageProxy.sendMessage(address_, confirm,txId);
            
                                                	            	confirmtime_e=System.currentTimeMillis();
            	 inferiorrecord.setConfirmtime_e(confirmtime_e);
            	            	from_.logIncoming(confirm);
                from_.logOutgoing(retMsg);
                       
        }
        catch (Exception e)
        {
            logger.debug("" + address_ +
                         "confirmϢõӦʱ쳣" + e.getMessage());
            status = Status.STATUS_FAULT;
        }
        if (retMsg != null)
        {
            switch (retMsg.getType())
            {
                case Message.TYPE_CONFIRMED:
                    status = Status.STATUS_CONFIRMED;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "]ִconfirm");
                    result = true;
                    break;
                case Message.TYPE_CANCELLED:
                    status = Status.STATUS_CANCELLED;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "]ִconfirmɷConfirmedϢ");
                    break;
                case Message.TYPE_FAULT:
                    status = Status.STATUS_FAULT;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId + "]confirmִ:" +
                                 ((Fault)retMsg).getFaultText());
                    break;
                case Message.TYPE_HAZARD:
                    status = Status.STATUS_FAULT;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "]confirmִܵHazardϢ:"
                                 + ((Hazard)retMsg).geHazardInfo());
                    break;
                default:
                    status = Status.STATUS_FAULT;
            }
        }
        try {
			TransactionDB.inferiorRecord2DB(inferiorrecord);
		} catch (SQLException e) {
						e.printStackTrace();
		}
        return result;
    }
    
    public synchronized boolean confirm_one_phase(String transactionid)
    {
        boolean result = false;
        status = Status.STATUS_CONFIRMING;
        inferiorrecord.setStatus(status);
        DBLog.logInfeirorStatus(this);
        ConfirmOnePhase confirm = new ConfirmOnePhase();
        confirm.setInferiorIdentifier(inferId);
        confirm.setTransactionId(txId);
        Message retMsg = null;
        try
        {
            logger.debug("ʼַ:" + address_ + "commit_one_phaseϢ");
                                    confirmtime_b=System.currentTimeMillis();
            inferiorrecord.setConfirmtime_b(confirmtime_b);
            retMsg=MessageProxy.sendMessage(address_, confirm,txId);
                       
                      
                        	            	confirmtime_e=System.currentTimeMillis();
            	 inferiorrecord.setConfirmtime_e(confirmtime_e);
            	            	 from_.logIncoming(confirm);
                 from_.logOutgoing(retMsg);
                  }
        catch (Exception e)
        {
            logger.debug("" + address_ +
                         "commit_one_phaseϢõӦʱ쳣" + e.getMessage());
            status = Status.STATUS_FAULT;
        }
        if (retMsg != null)
        {
            switch (retMsg.getType())
            {
                case Message.TYPE_CONFIRMED:
                    status = Status.STATUS_CONFIRMED;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "]ִcommit_one_phase");
                    result = true;
                    break;
                case Message.TYPE_CANCELLED:
                    status = Status.STATUS_CANCELLED;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "]ִcommit_one_phaseɽܵCancelledϢ");
                    break;
                case Message.TYPE_FAULT:
                    status = Status.STATUS_FAULT;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "]commit_one_phaseִ:" +
                                 ((Fault)retMsg).getFaultText());
                    break;
                case Message.TYPE_HAZARD:
                    status = Status.STATUS_FAULT;
                    inferiorrecord.setStatus(status);
                    DBLog.logInfeirorStatus(this);
                    logger.debug("[" + inferId
                                 + "]commit_one_phaseִܵHazardϢ:"
                                 + ((Hazard)retMsg).geHazardInfo());
                    break;
                default:
            }
        }
        try {
			TransactionDB.inferiorRecord2DB(inferiorrecord);
		} catch (SQLException e) {
						e.printStackTrace();
		}
        return result;
    }
    
    public void enrolled(String transactionid)
    {
        logger.debug("enrolledֱsuperior");
    }
        public void SetReturnMsg(String rmsg){
    	ReturnMsg=rmsg;
    }
    	public long getCanceltime_b() {
		return canceltime_b;
	}
	public long getCanceltime_e() {
		return canceltime_e;
	}
	public long getConfirmtime_b() {
		return confirmtime_b;
	}
	public long getConfirmtime_e() {
		return confirmtime_e;
	}
	public long getPreparetime_b() {
		return preparetime_b;
	}
	public long getPreparetime_e() {
		return preparetime_e;
	}
}
