
package org.act.services.transaction.manager;


import java.util.*;
import org.act.services.transaction.messages.Status;
public class SuperiorContext {
	 
    private String txId = null;
    
    private String superId = null;
    
    private String superAddress = null;
    
    private Hashtable inferiors = null;
    
    private String txStatus = null;
    
    private Vector confirmSet = null;
    
    private boolean atom = true;
    
    private boolean topTransaction;
    
    private List compensationAddrList = null;
    
    public SuperiorContext(String transactionId)
    {
        this.txId = transactionId;
        inferiors = new Hashtable();
        compensationAddrList = new ArrayList();
    }
    
    public void setTransactionId(String txID)
    {
        this.txId = txID;
    }
    
    public void setSuperiorId(String superiorId)
    {
        this.superId = superiorId;
    }
    
    public String getSuperiorId()
    {
        return this.superId;
    }
    
    public void setSuperiorAddress(String address)
    {
        this.superAddress = address;
    }
    
    public String getSuperiorAdress()
    {
        return this.superAddress;
    }
    
    public void setInferiorResource(String inferiorId,
                                    InferiorResource inferiorResource)
    {
        inferiors.put(inferiorId, inferiorResource);
       
    }
    
    public InferiorResource getInferiorResource(String inferiorId)
    {
        return (InferiorResource)inferiors.get(inferiorId);
    }
    
    public InferiorResource getInferiorResource(int pos)
    {
        Vector reses = getInferiorResource();
        if (reses != null && pos < reses.size() && pos >= 0)
        {
            return (InferiorResource)(reses.get(pos));
        }
        else
        {
            return null;
        }
    }
    
    public InferiorResource removeInferiorReource(String inferiorId)
    {
        return (InferiorResource)inferiors.remove(inferiorId);
    }
    
    public Vector getInferiorResource()
    {
        Vector infs = getInferiorList();
        Vector ret = null;
        if (infs != null)
        {
            ret = new Vector();
            for (int i = 0; i < infs.size(); i++)
            {
                String inf = (String)infs.get(i);
                InferiorResource res = getInferiorResource(inf);
                ret.add(res);
            }
        }
        return ret;
    }
    
    public void setInferiorSatuts(String inferiorId, String inferiorStatus)
    {
        InferiorResource resource = (InferiorResource)inferiors.get(inferiorId);
        if (resource != null)
        {
            resource.setSatus(inferiorStatus);
        }
    }
    
    public String getInferiorStatus(String inferiorId)
    {
        String status = Status.STATUS_UNKNOWN;
        InferiorResource resource = (InferiorResource)inferiors.get(inferiorId);
        if (resource != null)
        {
            status = resource.getSatus();
        }
        return status;
    }
    
    public Vector getInferiorList()
    {
        java.util.Set set = inferiors.keySet();
        Vector ret = new Vector();
        if (!set.isEmpty())
        {
            java.util.Iterator it = set.iterator();
            while (it.hasNext())
            {
                ret.add((String)it.next());
            }
        }
        return ret;
    }
    
    public int getInferiorCount()
    {
        return inferiors.size();
    }
    
    public void setConfirmSet(Vector confirmSet)
    {
        this.confirmSet = confirmSet;
    }
    
    public Vector getConfirmSet()
    {
        return this.confirmSet;
    }
    
    public Vector getNoConfirmSet()
    {
        Vector noConfirm = new Vector();
                if (confirmSet != null)
        {
            Vector list = getInferiorList();
            for (int i = 0; i < list.size(); i++)
            {
                String infId = (String)list.get(i);
                if (!confirmSet.contains(infId))
                {
                    noConfirm.add(infId);
                }
            }
        }
        return noConfirm;
    }
    
    public void setAtom(boolean atom)
    {
        this.atom = atom;
    }
    
    public boolean isAtom()
    {
        return this.atom;
    }
    
    public boolean isCohesion()
    {
        return !this.atom;
    }
    
    public void setTopTransaction(boolean isTopTx)
    {
        this.topTransaction = isTopTx;
    }
    
    public boolean isTopTransaction()
    {
        return this.topTransaction;
    }
    
    public boolean isNestTransaction()
    {
        return  !this.topTransaction;
    }
    
    public void setTxStatus(String status)
    {
        this.txStatus = status;
    }
    
    public String getTxStatus()
    {
        return this.txStatus;
    }
    
    public String getTransactionId()
    {
        return this.txId;
    }
    
    public List getCompansationAddrList()
    {
        return this.compensationAddrList;
    }
}
