
package org.act.services.transaction.messages;
import java.util.*;
import org.act.services.transaction.util.*;


public class CancelInferiors extends Message{
	
	
    private String transactid_;
    
    private Vector inflist_ = null;
    
    public CancelInferiors()
    {
        super("btp:cancel-inferiors", Message.TYPE_CANCEL_INFERIORS);
    }
    
    public CancelInferiors(String trid)
    {
        super("btp:cancel-inferiors", Message.TYPE_CANCEL_INFERIORS);
        transactid_ = trid;
        inflist_ = new Vector();
    }
    
    public CancelInferiors(XElement el)
    {
        super(el, Message.TYPE_CANCEL_INFERIORS);
        String ns = el.getNamespace();
        ns = (ns == null ? "" : ns + ":");
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        transactid_ = pickString(h,
                                 "/" + name_ + "/" + ns +
                                 "transaction-identifier");
        inflist_ = h.get("/" + name_
                         + "/" + ns + "inferiors-list" + "/" + ns +
                         "inferior-identifier");
    }
    
    public void setTransactionIdentifier(String t)
    {
        transactid_ = t;
    }
    
    public String getTransactionIdentifier()
    {
        return transactid_;
    }
    
    public void addInferiorIdentifier(String id)
    {
        if (inflist_ == null)
        {
            inflist_ = new Vector();
        }
        inflist_.addElement(id);
    }
    
    public Vector getInferiorIdentifiers()
    {
        return inflist_;
    }
    
    public String getInferiorIdentifier(int pos)
    {
        if (inflist_ == null || pos >= inflist_.size())
        {
            return null;
        }
        return
            (String)inflist_.elementAt(pos);
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:cancel-inferiors");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:transaction-identifier", transactid_));
        if (inflist_ != null)
        {
            XElement a = new XElement("btp:inferiors-list");
            for (int i = 0; i < inflist_.size(); i++)
            {
                a.addElement(
                    new XElement("btp:inferior-identifier",
                                 (String)inflist_.elementAt(i)));
            }
            el.addElement(a);
        }
        addQualifiers(el);
        addTargetAddress(el);
        addReplyAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        CancelInferiors obj = new CancelInferiors("transact1");
        obj.addInferiorIdentifier("inferiorid1");
        System.out.println(obj.toXml().toString());
    }
}
