
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class CancelTransaction extends Message{
	
	
    private String transactid_;
    
    private boolean reporthazard_ = true;
    
    public CancelTransaction(String trid)
    {
        super("btp:cancel-transaction", Message.TYPE_CANCEL_TRANSACTION);
        transactid_ = trid;
    }
    
    public CancelTransaction(String trid, boolean reporthazard)
    {
        super("btp:cancel-transaction", Message.TYPE_CANCEL_TRANSACTION);
        transactid_ = trid;
        reporthazard_ = reporthazard;
    }
    
    public CancelTransaction(XElement el)
    {
        super(el, Message.TYPE_CANCEL_TRANSACTION);
        String ns = el.getNamespace();
        ns = (ns == null ? "" : ns + ":");
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        transactid_ = pickString(h,
                                 "/" + name_ + "/" + ns +
                                 "transaction-identifier");
        Object obj = h.getSingle("/" + name_ + "/" + ns + "report-hazard");
        if (obj != null)
        {
            reporthazard_ = !obj.toString().equalsIgnoreCase("false");
        }
    }
    
    public String getTransactionIdentifier()
    {
        return transactid_;
    }
    
    public boolean getReportHazard()
    {
        return reporthazard_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:cancel-transaction");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:transaction-identifier", transactid_));
        el.addElement(
            new XElement("btp:report-hazard", (reporthazard_ ? "true" : "false")));
        addQualifiers(el);
        addTargetAddress(el);
        addReplyAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        CancelTransaction obj = new CancelTransaction("transact1");
        System.out.println(obj.toXml().toString());
    }
	
}
