
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class ConfirmOnePhase extends Message{
	
	 
 private boolean reportHazard_ = true;
 private String inferiorIdentifier_ = null;
 
 public ConfirmOnePhase()
 {
     super("btp:confirm-one-phase", Message.TYPE_CONFIRM_ONE_PHASE);
 }
 
 public ConfirmOnePhase(XElement el)
 {
     super(el, Message.TYPE_CONFIRM_ONE_PHASE);
     XHashtable h = el.toHashtable();
     id_ = el.getAttribute("id");
     Object obj = h.getSingle("/btp:confirm-one-phase/btp:report-hazard");
     if (obj != null)
     {
         reportHazard_ = !obj.toString().equalsIgnoreCase("false");
     }
     obj = h.getSingle("/btp:confirm-one-phase/btp:inferior-identifier");
     if (obj != null)
     {
         inferiorIdentifier_ = obj.toString();
     }
 }
 
 public void setReportHazard(boolean report)
 {
     reportHazard_ = report;
 }
 
 public boolean getReportHazard()
 {
     return reportHazard_;
 }
 
 public void setInferiorIdentifier(String uri)
 {
     inferiorIdentifier_ = uri;
 }
 
 public String getInferiorIdentifier()
 {
     return inferiorIdentifier_;
 }
 
 public XElement toXml()
 {
     XElement el = new XElement("btp:confirm-one-phase");
     if (id_ != null)
     {
         el.addAttribute("id", id_);
     }
     el.addElement(
         new XElement("btp:inferior-identifier", inferiorIdentifier_));
     el.addElement(
         new XElement("btp:report-hazard", (reportHazard_ ? "true" : "false")));
     addQualifiers(el);
     addTargetAddress(el);
     addSenderAddress(el);
     return el;
 }
 public static void main(String args[])
 {
     ConfirmOnePhase obj = new ConfirmOnePhase();
     obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
     obj.setReportHazard(false);
     System.out.println(obj.toString());
     obj = new ConfirmOnePhase(obj.toXml());
     System.out.println(obj.toString());
 }
}
