
package org.act.services.transaction.messages;
import org.act.metaset.Attribute;
import org.act.metaset.QName;
import org.act.metaset.Metaset;
import org.act.services.transaction.util.*;


public class ContextReply extends Message{
	 
	    
    public static String ContextReply_completed = "completed";
    
    public static String ContextReply_incomplete = "incomplete";
    
    public static String ContextReply_related = "related";
    
    public static String ContextReply_repudiated = "repudiated";
    
    private String supid_;
    
    private String completion_;
    
    private String inferiorId = null;
    
    public ContextReply(String supid, String compl)
    {
        super("btp:context-reply", Message.TYPE_CONTEXT_REPLY);
        supid_ = supid;
        completion_ = compl;
    }
    
    public ContextReply(XElement el)
    {
        super(el, Message.TYPE_CONTEXT_REPLY);
        String ns = el.getNamespace();
        ns = (ns == null ? "" : ns + ":");
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        inferiorId = pickString(h,
                                "/" + name_ + "/" + ns + "inferior-identifier");
        supid_ = pickString(h, "/" + name_ + "/" + ns + "superior-identifier");
        completion_ = pickString(h,
                                 "/" + name_ + "/" + ns + "completion-status");
    }
    
    public String getSuperiorIdentifier()
    {
        return supid_;
    }
    
    public String getCompletionStatus()
    {
        return completion_;
    }
    
    public void setInferiorId(String infId)
    {
        this.inferiorId = infId;
    }
    
    public String getInferiorId()
    {
        return this.inferiorId;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:context-reply");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(new XElement("btp:inferior-identifier", inferiorId));
        el.addElement(new XElement("btp:superior-identifier", supid_));
        el.addElement(new XElement("btp:completion-status", completion_));
        addQualifiers(el);
        addTargetAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        ContextReply obj = new ContextReply("supid1", "completed");
        System.out.println(obj.toXml().toString());
    }
        public Metaset toServiceSet(){
    	Metaset conp_s=new Metaset("btp:context-reply");
    	if (id_ != null)
        {
    		conp_s.add(new Attribute(new QName("id"),id_));
        }
    	    	Metaset InfId_s=new Metaset(new QName("btp:inferior-identifier"));
    	InfId_s.setValue(inferiorId);
    	conp_s.add(InfId_s);
    	    	Metaset supId_s=new Metaset(new QName("btp:superior-identifier"));
    	supId_s.setValue(supid_);
    	conp_s.add(supId_s);
    	    	Metaset coms_s=new Metaset(new QName("btp:completion-status"));
    	coms_s.setValue(completion_);
    	conp_s.add(coms_s);
    	    	            	
    	return conp_s;
    	
    }
}
