
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class InferiorTimeout extends Qualifier{
	 
    private int seconds_ = -1;
    
    private String decision_ = "cancel";
    
    public InferiorTimeout(int seconds)
    {
        this(seconds, Message.TYPE_CANCEL);
    }
    
    public InferiorTimeout(int seconds, int decision)
    {
        super("btpq:inferior-timeout");
        addElement(new XElement("btpq:timeout", Integer.toString(seconds)));
        seconds_ = seconds;
        if (decision == Message.TYPE_CONFIRM)
        {
            decision_ = "confirm";
        }
        addElement(new XElement("btpq:intended-decision", decision_));
    }
    
    public InferiorTimeout(XElement el)
    {
        super(el);
        XElement tlim = elementAt(0);
        if (tlim != null)
        {
            try
            {
                seconds_ = Integer.parseInt(tlim.getValue());
            }
            catch (NumberFormatException ne)
            {
                seconds_ = -1;
            }
        }
        XElement decision = elementAt(1);
        if (decision != null)
        {
            decision_ = decision.getValue();
        }
    }
    
    public int getTimeout()
    {
        return seconds_;
    }
    
    public String getDecision()
    {
        return decision_;
    }
    public static void main(String[] args)
    {
        InferiorTimeout inferiorTimeout1 = new InferiorTimeout(1000);
        System.out.println(inferiorTimeout1.toXml());
    }	
}
