
package org.act.services.transaction.messages;
import java.util.*;
import org.act.services.transaction.util.*;

public class Qualifier {
	 
    private String name = null;
    
    private String group = null;
    
    private boolean propagate = false;
    
    private boolean mustunderstand = true;
    
    private Vector content = null;
    private String scontent = null;
    
    public Qualifier(String name)
    {
        this.name = name;
    }
    
    public Qualifier(XElement el)
    {
        name = el.getName();
        XVector v = el.getNodes();
        if (v != null)
        {
            content = v.getElements();
        }
    }
    
    public String getName()
    {
        return name;
    }
    
    public void setGroup(String group)
    {
        this.group = group;
    }
    
    public void setToBePropagated(boolean t)
    {
        propagate = t;
    }
    
    public void setMustBeUnderstood(boolean m)
    {
        mustunderstand = m;
    }
    
    public void addElement(XElement c)
    {
        if (content == null)
        {
            content = new Vector();
        }
        content.addElement(c);
    }
    
    public XElement elementAt(int pos)
    {
        if (content == null || pos < 0 || content.size() <= pos)
        {
            return null;
        }
        else
        {
            return (XElement)content.elementAt(pos);
        }
    }
    
    public void setContent(Vector v)
    {
        content = v;
    }
    
    public void setContent(String s)
    {
        scontent = s;
    }
    
    public XElement toXml()
    {
        if (name == null)
        {
            return null;
        }
        if (!name.startsWith("btpq:"))
        {
            name = "btpq:" + name;
        }
        XElement el = new XElement(name);
        if (!mustunderstand)
        {
            el.addAttribute("btp:must-be-understood", "false");
        }
        if (propagate)
        {
            el.addAttribute("btp:to-be-propagated", "true");
        }
        if (content != null)
        {
            for (int i = 0; i < content.size(); i++)
            {
                el.addElement((XElement)content.elementAt(i));
            }
        }
        else if (scontent != null)
        {
            el.setValue(scontent);
        }
        return el;
    }
    public static void main(String[] args)
    {
        try
        {
            String q = "<btpq:inferior-timeout xmlns:btpq='urn:oasis:names:tc:BTP:1.0:qualifiers' xmlns:btp='urn:oasis:names:tc:BTP:1.0:core' btp:must-be-understood='false' btp:to-be-propagated='true'>1800</btpq:inferior-timeout>";
            XElement x = BTPUtil.changeXElement(q);
            String na = x.getNamespace();
            System.err.print(x.toString());
            Qualifier qualifier1 = new Qualifier(x);
            System.out.println(qualifier1.toXml());
                    }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }
	
}
