
package org.act.services.transaction.messages;
import java.util.*;
import org.act.services.transaction.util.*;

public class Redirect extends Message{
	
	 
    private String superiorIdentifier_ = null;
    
    private String inferiorIdentifier_ = null;
    
    Vector oldaddr_ = null;
    
    Vector newaddr_ = null;
    
    public Redirect()
    {
        super("btp:redirect", Message.TYPE_REDIRECT);
    }
    
    public Redirect(XElement el)
    {
        super(el, Message.TYPE_REDIRECT);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:redirect/btp:superior-identifier");
        if (obj != null)
        {
            superiorIdentifier_ = obj.toString();
        }
        obj = h.getSingle("/btp:redirect/btp:inferior-identifier");
        if (obj != null)
        {
            inferiorIdentifier_ = obj.toString();
        }
        oldaddr_ = this.pickAddrSet(h, "/btp:redirect/btp:old-address");
        newaddr_ = this.pickAddrSet(h, "/btp:redirect/btp:new-address");
    }
    
    public void setSuperiorIdentifier(String uri)
    {
        superiorIdentifier_ = uri;
    }
    
    public String getSuperiorIdentifier()
    {
        return superiorIdentifier_;
    }
    
    public void setInferiorIdentifier(String uri)
    {
        inferiorIdentifier_ = uri;
    }
    
    public String getInferiorIdentifier()
    {
        return inferiorIdentifier_;
    }
    
    public void addOldAddress(Address add)
    {
        if (oldaddr_ == null)
        {
            oldaddr_ = new Vector();
        }
        oldaddr_.addElement(add);
    }
    
    public Vector getOldAddresses()
    {
        return oldaddr_;
    }
    
    public Address getOldAddress(int pos)
    {
        if (oldaddr_ == null || pos >= oldaddr_.size())
        {
            return null;
        }
        else
        {
            return (Address)oldaddr_.elementAt(pos);
        }
    }
    
    protected void addOldAddress(XElement el)
    {
        if (oldaddr_ != null)
        {
            for (int i = 0; i < oldaddr_.size(); i++)
            {
                XElement old = new XElement("btp:old-address");
                old.addElement(((Address)oldaddr_.elementAt(i)).toXml());
                el.addElement(old);
            }
        }
    }
    
    public void addNewAddress(Address add)
    {
        if (newaddr_ == null)
        {
            newaddr_ = new Vector();
        }
        newaddr_.addElement(add);
    }
    
    public Vector getNewAddresses()
    {
        return newaddr_;
    }
    
    public Address getNewAddress(int pos)
    {
        if (newaddr_ == null || pos >= newaddr_.size())
        {
            return null;
        }
        else
        {
            return (Address)newaddr_.elementAt(pos);
        }
    }
    
    protected void addNewAddress(XElement el)
    {
        if (newaddr_ != null)
        {
            for (int i = 0; i < newaddr_.size(); i++)
            {
                XElement newa = new XElement("btp:new-address");
                newa.addElement(((Address)newaddr_.elementAt(i)).toXml());
                el.addElement(newa);
            }
        }
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:redirect");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:superior-identifier", superiorIdentifier_));
        el.addElement(
            new XElement("btp:inferior-identifier", inferiorIdentifier_));
        addOldAddress(el);
        addNewAddress(el);
        addQualifiers(el);
        addTargetAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        System.out.println("===== Build redirect");
        Redirect obj = new Redirect();
        obj.setSuperiorIdentifier("http://www.myaddress.com:8080/superiorid");
        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
        obj.addOldAddress(new Address("oldaddress1"));
        obj.addOldAddress(new Address("oldAddress2"));
        obj.addNewAddress(new Address("newaddress1"));
        obj.addNewAddress(new Address("new Address2"));
        System.out.println(obj.toString());
        System.out.println("===== Extract redirect");
        obj = new Redirect(obj.toXml());
        System.out.println(obj.toString());
    }
}
