
package org.act.services.transaction.messages;
import java.util.*;
import org.act.services.transaction.util.*;


public class RequestInferiorStatuses extends Message{
	
	
 private String targetid_;
 
 private Vector inflist_ = null;
 
 public RequestInferiorStatuses(String targetId)
 {
     super("btp:request-inferior-statuses",
           Message.TYPE_REQUEST_INFERIOR_STATUSES);
     targetid_ = targetId;
 }
 
 public RequestInferiorStatuses(XElement el)
 {
     super(el, Message.TYPE_REQUEST_INFERIOR_STATUSES);
     String ns = el.getNamespace();
     ns = (ns == null ? "" : ns + ":");
     XHashtable h = el.toHashtable();
     id_ = el.getAttribute("id");
     targetid_ = pickString(h,
                            "/" + name_ + "/" + ns + "target-identifier");
     inflist_ = h.get("/" + name_
                      + "/" + ns + "inferiors-list" + "/" + ns +
                      "inferior-identifier");
 }
 
 public String getTargetIdentifier()
 {
     return targetid_;
 }
 
 public void addInferior(String id)
 {
     if (inflist_ == null)
     {
         inflist_ = new Vector();
     }
     inflist_.addElement(id);
 }
 
 public Vector getInferiorsList()
 {
     return inflist_;
 }
 
 public void setInferiorsList(Vector list)
 {
     this.inflist_ = list;
 }
 
 public String getInferior(int pos)
 {
     if (inflist_ == null || pos >= inflist_.size())
     {
         return null;
     }
     return
         (String)inflist_.elementAt(pos);
 }
 
 public XElement toXml()
 {
     XElement el = new XElement("btp:request-inferior-statuses");
     if (id_ != null)
     {
         el.addAttribute("id", id_);
     }
     el.addElement(
         new XElement("btp:target-identifier", targetid_));
     if (inflist_ != null)
     {
         XElement a = new XElement("btp:inferiors-list");
         for (int i = 0; i < inflist_.size(); i++)
         {
             a.addElement(
                 new XElement("btp:inferior-identifier",
                              (String)inflist_.elementAt(i)));
         }
         el.addElement(a);
     }
     addQualifiers(el);
     addTargetAddress(el);
     addReplyAddress(el);
     return el;
 }
 public static void main(String args[])
 {
     RequestInferiorStatuses obj = new RequestInferiorStatuses("transact1");
          System.out.println(obj.toXml().toString());
 }
}
