
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class RequestStatus extends Message{
	  
    private String targetid_;
    
    public RequestStatus()
    {
        super("btp:request-status", Message.TYPE_REQUEST_STATUS);
    }
    
    public RequestStatus(XElement el)
    {
        super(el, Message.TYPE_REQUEST_STATUS);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:request-status/btp:target-identifier");
        if (obj != null)
        {
            targetid_ = obj.toString();
        }
    }
    
    public void setTargetIdentifier(String target)
    {
        targetid_ = target;
    }
    
    public String getTargetIdentifier()
    {
        return targetid_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:request-status");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(new XElement("btp:target-identifier", targetid_));
        addQualifiers(el);
        addTargetAddress(el);
        addReplyAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        System.out.println("===== Build request-status");
        RequestStatus obj = new RequestStatus();
        obj.setTargetIdentifier("http://www.myaddress.com:8080/targetid");
        System.out.println(obj.toString());
        System.out.println("===== Extract request-status");
        obj = new RequestStatus(obj.toXml());
        System.out.println(obj.toString());
    }
}
