
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class Resign extends Message{
	
	
 private boolean responseRequested_ = false;
 
 private String superiorIdentifier_ = null;
 
 private String inferiorIdentifier_ = null;
 
 public Resign()
 {
     super("btp:resign", Message.TYPE_RESIGN);
 }
 
 public Resign(XElement el)
 {
     super(el, Message.TYPE_RESIGN);
     XHashtable h = el.toHashtable();
     id_ = el.getAttribute("id");
     Object obj = h.getSingle("/btp:resign/btp:response-requested");
     if (obj != null)
     {
         responseRequested_ = !obj.toString().equalsIgnoreCase("false");
     }
     obj = h.getSingle("/btp:resign/btp:superior-identifier");
     if (obj != null)
     {
         superiorIdentifier_ = obj.toString();
     }
     obj = h.getSingle("/btp:resign/btp:inferior-identifier");
     if (obj != null)
     {
         inferiorIdentifier_ = obj.toString();
     }
 }
 
 public void setResponseRequested(boolean response)
 {
     responseRequested_ = response;
 }
 
 public boolean getResponseRequested()
 {
     return responseRequested_;
 }
 
 public void setSuperiorIdentifier(String uri)
 {
     superiorIdentifier_ = uri;
 }
 
 public String getSuperiorIdentifier()
 {
     return superiorIdentifier_;
 }
 
 public void setInferiorIdentifier(String uri)
 {
     inferiorIdentifier_ = uri;
 }
 
 public String getInferiorIdentifier()
 {
     return inferiorIdentifier_;
 }
 
 public XElement toXml()
 {
     XElement el = new XElement("btp:resign");
     if (id_ != null)
     {
         el.addAttribute("id", id_);
     }
     el.addElement(
         new XElement("btp:superior-identifier", superiorIdentifier_));
     el.addElement(
         new XElement("btp:inferior-identifier", inferiorIdentifier_));
     el.addElement(
         new XElement("btp:response-requested",
                      (responseRequested_ ? "true" : "false")));
     addQualifiers(el);
     addTargetAddress(el);
     addSenderAddress(el);
     return el;
 }
 public static void main(String args[])
 {
     System.out.println("===== Build resign");
     Resign obj = new Resign();
     obj.setSuperiorIdentifier("http://www.myaddress.com:8080/superiorid");
     obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
     obj.setResponseRequested(false);
     System.out.println(obj.toString());
     System.out.println("===== Extract resign");
     obj = new Resign(obj.toXml());
     System.out.println(obj.toString());
 }
}
