
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class TransactionCancelled extends Message{
	  
    private String transactid_;
    
    public TransactionCancelled(String trid)
    {
        super("btp:transaction-cancelled", Message.TYPE_TRANSACTION_CANCELLED);
        transactid_ = trid;
    }
    
    public TransactionCancelled(XElement el)
    {
        super(el, Message.TYPE_TRANSACTION_CANCELLED);
        String ns = el.getNamespace();
        ns = (ns == null ? "" : ns + ":");
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        transactid_ = pickString(h,
                                 "/" + name_ + "/" + ns +
                                 "transaction-identifier");
    }
    public String getTransactionIdentifier()
    {
        return transactid_;
    }
    public XElement toXml()
    {
        XElement el = new XElement("btp:transaction-cancelled");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:transaction-identifier", transactid_));
        addQualifiers(el);
        addTargetAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        TransactionCancelled obj = new TransactionCancelled("transact1");
        System.out.println(obj.toXml().toString());
    }
	
}
