
package org.act.services.transaction.util;

import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.act.metaset.*;
public class BTPUtil {
    
    private static XElement parseDocument(java.io.InputStream is)
        throws Exception
    {
        XElement xDoc = null;
        DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
        dbFactory.setValidating(false);
        DocumentBuilder db = dbFactory.newDocumentBuilder();
        org.w3c.dom.Document doc = db.parse(is);
        xDoc = changeXElement(doc.getDocumentElement());
        return xDoc;
    }
    
    public static XElement parseDocument(String file)
        throws Exception
    {
        java.io.File file1 = new java.io.File(file);
        java.io.InputStream is = new java.io.FileInputStream(file);
        return parseDocument(is);
    }
    
    public static XElement changeXElement(String xmlFragment)
        throws Exception
    {
        XElement xEle = null;
        xmlFragment = "<?xml version='1.0' encoding='gb2312'?>\n" + xmlFragment;
                java.io.InputStream in = new java.io.ByteArrayInputStream(xmlFragment.getBytes());
        return parseDocument(in);
    }
    
    public static XElement changeXElement(Element ele)
    {
        XElement xEle = new XElement(ele.getTagName());
        org.w3c.dom.NamedNodeMap attrs = ele.getAttributes();
        if (attrs != null)
        {
            for (int i = 0; i < attrs.getLength(); i++)
            {
                String attrName = attrs.item(i).getNodeName();
                String attrVal = attrs.item(i).getNodeValue();
                xEle.addAttribute(attrName, attrVal);
            }
        }
        if (countKids(ele, Node.TEXT_NODE) == 1 &&
            countKids(ele, Node.ELEMENT_NODE) == 0)
        {
            String val = getChildCharacterData(ele);
            xEle.setValue(val.trim());
            return xEle;
        }
        org.w3c.dom.NodeList nodes = ele.getChildNodes();
        if (nodes != null)
        {
            for (int j = 0; j < nodes.getLength(); j++)
            {
                org.w3c.dom.Node node = nodes.item(j);
                switch (node.getNodeType())
                {
                    case Node.ELEMENT_NODE:
                    {
                        Element nodeE = (Element)node;
                        xEle.addElement(changeXElement(nodeE));
                    }
                    default:
                }
            }
        }
        return xEle;
    }
    
    private static int countKids(Element elem, short nodeType)
    {
        int nkids = 0;
        for (Node n = elem.getFirstChild(); n != null; n = n.getNextSibling())
        {
            if (n.getNodeType() == nodeType)
            {
                nkids++;
            }
        }
        return nkids;
    }
    
    static private String getChildCharacterData(Element parentEl)
    {
        if (parentEl == null)
        {
            return null;
        }
        Node tempNode = parentEl.getFirstChild();
        StringBuffer strBuf = new StringBuffer();
        CharacterData charData;
        while (tempNode != null)
        {
            switch (tempNode.getNodeType())
            {
                case Node.TEXT_NODE:
                case Node.CDATA_SECTION_NODE:
                    charData = (CharacterData)tempNode;
                    strBuf.append(charData.getData());
                    break;
            }
            tempNode = tempNode.getNextSibling();
        }
        return strBuf.toString();
    }
    
    public static String toHtml(String xml)
    {
        StringTokenizer st = new StringTokenizer(xml, "<>/", true);
        StringBuffer buf = new StringBuffer();
        while (st.hasMoreTokens())
        {
            String tok = st.nextToken();
            if (tok.equals("<"))
            {
                buf.append("&lt;");
            }
            else if (tok.equals(">"))
            {
                buf.append("&gt;");
            }
            else
            {
                buf.append(tok);
            }
        }
        return buf.toString();
    }
    
    public static String formatMessage(String message)
    {
        StringBuffer buf = new StringBuffer(message);
        try
        {
            String str1 = "&lt;", str2 = "&gt;";
            while (buf.toString().indexOf(str1) != -1
                   || buf.toString().indexOf(str2) != -1)
            {
                int pos1 = buf.toString().indexOf(str1);
                int pos2 = buf.toString().indexOf(str2);
                boolean first = false;
                if (pos1 != -1)
                {
                    buf.replace(pos1, pos1 + 4, "<");
                    first = true;
                }
                if (pos2 != -1 && pos2 > pos1)
                {
                    if (first)
                    {
                        pos2 = pos2 - 3;
                    }
                    buf.replace(pos2, pos2 + 4, ">");
                }
            }
        }
        catch (Exception e)
        {
            System.err.println("Ϣַת:" + e.getMessage());
        }
        return buf.toString();
    }
    public static void main(String[] args)
    {
    try
    {
        BTPUtil BTPUtil1 = new BTPUtil();
             
        String demo="<btp:address><btp:binding-name>soap-http-1</btp:binding-name><btp:binding-address>sup-addr-202.112.137.7</btp:binding-address></btp:address>";
        Metaset ser=BTPUtil1.toServicesSet(demo);
        System.err.print(ser.toXML().toString());
    }
    catch (Exception e)
    {
        e.printStackTrace();
    }
}
        public static Metaset toServicesSet(String StrBtp){
    	java.io.InputStream in = new java.io.ByteArrayInputStream(StrBtp.getBytes());
    	MetasetParser SAXParser=new MetasetParser();
    	return SAXParser.parse(in);
    	
    }
}
