
package org.act.services;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import org.act.services.protocol.http.HTTPConstants;
import org.act.services.protocol.http.MimeHeaders;

public class AttachmentImpl implements IAttachment {
    public static final int BUFFERSIZE = 4096;
    private long length = 0;
    private MimeHeaders mimeHeaders = null;
        private ByteArrayOutputStream attachoutput = null;
    private byte[] attach = null;
    private String contentType;
                                                                                                                        
    public AttachmentImpl() {
            }
    public AttachmentImpl(byte[] in, MimeHeaders heads) {
        this.attach = in;
        this.mimeHeaders = heads;
    }
                                                                                                                                                                                        
    public MimeHeaders getMimeHeaders() throws IOException {
        return mimeHeaders;
    }
    
    public void setMimeHeaders(MimeHeaders mimeHeaders) {
        this.mimeHeaders = mimeHeaders;
    }
                                public void setAttachment(byte[] input) {
        this.attach = input;
    }
    
    
    public void setAttachment(InputStream input) throws IOException  {
        byte[] content = new byte[0];
        byte[] temp = new byte[BUFFERSIZE];
        int c;
        boolean flag = true;
        int i = 1;
        while (flag == true) {
            for (i = 0; i < BUFFERSIZE; i++) {
                c = input.read();
                if (c == -1) {
                    flag = false;
                    break;
                }
                temp[i] = (byte) c;
            }
            byte[] contenttemp = new byte[content.length + i];
                        System.arraycopy(content, 0, contenttemp, 0, content.length);
                        System.arraycopy(temp, 0, contenttemp, content.length, i);
            content = contenttemp;
        }
        this.attach = content;
    }
    
    public ByteArrayOutputStream getAttachoutput() {
        ByteArrayOutputStream output = new ByteArrayOutputStream();
        if (attach != null) {
            try {
                output.write(attach);
            } catch (IOException e) {
                                e.printStackTrace();
            }
        }
        return output;
    }
    public byte[] getAttachment() {
       if(attach==null){
           attach=new byte[0];
       }
        return attach;
    }
    
    public String getContentType() {
        if (contentType != null) {
            return contentType;
        } else if (this.mimeHeaders != null) {
            String[] header = this.mimeHeaders
                    .getHeader(HTTPConstants.CONTENTTYPE);
            if (header.length != 0) {
                this.contentType = header[0];
            }
            else{
                this.contentType=null;
            }
        }
        return contentType;
    }
    public void setContentType(String content) {
        this.contentType = content;
    }
}
