package org.act.services.protocol.http;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.Socket;
import java.net.URL;
import org.act.metaset.Metaset;
import org.act.services.IAttachment;
import org.act.services.ITransportContext;
import org.act.services.pool.IObjectPool;
import org.act.services.runtime.Application;
import org.act.services.thread.ThreadPoolRunnable;

public class HTTPReplyTransportContext implements
        ITransportContext.ResponseTransportContext {
    private String urlStr;
    private String path;
    private OutputStream os = null;
    private Socket socket = null;
    private InputStream in = null;
    private byte[] data;
    MimeHeaders headers = null;
    private Metaset content;
    URL url;
    private IAttachment[] attachments;
    private IObjectPool pool;
        public HTTPReplyTransportContext(String urlStr, IObjectPool pool) {
                this.urlStr = urlStr;
        this.pool = pool;
    }
    
    private OutputStream getOutputStream() throws IOException {
        if (os == null) {
            try {
                url = new URL(urlStr);
                if(Application.isDebug()){
                System.err.println(urlStr);
                }
                socket = new Socket(url.getHost(), url.getPort());
                socket.setKeepAlive(true);
                path = url.getPath();
                os = socket.getOutputStream();
            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return os;
    }
    public MimeHeaders getHeaders() {
        if (headers == null) {
            headers = new MimeHeaders();
        }
        return headers;
    }
    
    public void setData(byte[] bs) {
        this.data = bs;
    }
    
    public byte[] getData() {
        return data;
    }
    
    public String getPath() {
        return this.path;
    }
    
    public ThreadPoolRunnable getResponseHandler() {
        return new ThreadPoolRunnable() {
            public Object[] getInitData() {
                return null;
            }
            public void runIt(Object[] thData) {
                data = content.toDocument().getBytes();
                try {
                    MimeHeaders resHeaders = headers;
                                        
                    OutputStream out = getOutputStream();
                    out.write(("POST " + url.getPath() + " HTTP/1.0\r\n")
                            .getBytes());
                    out.write(("Content-Type: " + "text/xml;charset=UTF-8"
                            + "\r\n").getBytes());
                                        out.write(("Content-Length: " + data.length + "\r\n")
                            .getBytes());
                    out.write("\r\n".getBytes());
                    out.write(data);
                    out.flush();
                                        new HTTPRequestProcessor(socket, pool).runIt(null);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        };
    }
    
    public void setContent(Metaset response) {
                this.content = response;
    }
    
    public void setAttachments(IAttachment[] attachments) {
                this.attachments = attachments;
    }
    public Metaset getContent() throws IOException {
                return null;
    }
    public IAttachment[] getAttachments() throws IOException {
                return null;
    }
}
