
package org.act.services.protocol.http;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.metaset.MetasetParser;
import org.act.metaset.Metaset;
import org.act.services.ATransportContext;
import org.act.services.AttachmentImpl;
import org.act.services.ContentImpl;
import org.act.services.IAttachment;
import org.act.services.runtime.Application;
import org.act.services.thread.ThreadPoolRunnable;

public class HTTPTransportContext extends ATransportContext {
        private String path = null;
        private Socket socket = null;
    
    public Socket getSocket() {
        return socket;
    }
    
    public void setSocket(Socket socket) {
        this.socket = socket;
    }
    
    public String getTransportProtocolName() {
        return "http";
    }
    
    public String getPath() {
        return path;
    }
    
    public void setPath(String serviceName) {
        this.path = serviceName;
    }
    public static class HTTPRequestContext implements RequestTransportContext {
       
        private String  boundaryString=null;
        private Metaset content = null;
        private List  contentlist=new LinkedList();
        private MimeHeaders mHeaders=null;
        private InputStream innerIS=null; 
        
        public HTTPRequestContext(){
            
        }
        public HTTPRequestContext(MimeHeaders mimeheads,InputStream input){
            this.mHeaders=mimeheads;
            this.innerIS=input;
        }
        public Metaset getContent() throws IOException {
           content=getData();
         
            return content; 
        }
        public String getHeader(String name) {
            if (this.mHeaders == null)
                return null;
            if(mHeaders.getHeader( name )==null){
            	return null;
            }
            return this.mHeaders.getHeader( name )[0];
        }
        public Enumeration getHeaders(String name) {
            if (this.mHeaders == null)
                return null;
            Vector v = new Vector();
            v.addAll( Arrays.asList(this.mHeaders.getHeader(name)) );
            return v.elements();
        }
        public Enumeration getHeaderNames() {
            if (this.mHeaders == null)
                return null;
            Vector v = new Vector();
            for( Iterator i = this.mHeaders.getAllHeaders();i.hasNext();) {
                v.add( ((MimeHeader)i.next()).getName() );
            }
            return v.elements();
        }
        public void setMimeHeaders( MimeHeaders headers ) {
            this.mHeaders = headers;
        }
        public void setInputStream( InputStream ins ) {
            this.innerIS = ins;
        }
        public ServletInputStream getInputStream() throws IOException {
            return new ServletInputStream(){
                                public int read() throws IOException {
                    int c = innerIS.read();
                                        return c;
                }
                public long skip(long n) throws IOException {
                    return innerIS.skip( n );
                }
                public int available() throws IOException {
                    return innerIS.available();
                }
                public void close() throws IOException {
                    innerIS.close();
                }
                public synchronized void mark(int readlimit) {
                    innerIS.mark( readlimit );
                }
                public synchronized void reset() throws IOException {
                    innerIS.reset();
                }
                public boolean markSupported() {
                    return innerIS.markSupported();
                }
            };
        }
        
        private Metaset getData() throws IOException {
            if (content == null) {
           
              Enumeration headlist = getHeaders("Content-Type");
              if (headlist.hasMoreElements()) {
                  String head = (String) headlist.nextElement();
                  
                  int index=head.indexOf("boundary");
                 
                   switch (index) {
                  case -1:
                      boundaryString=null;
                      content = MetasetParser.getInstance().parse(
                          new ByteArrayInputStream(getContent(  getInputStream()
                                  ).toByteArray()));
                      break;
                  default:  
                       head=head.substring(index);
                       StringTokenizer token=new StringTokenizer(head,"\"");
                                              token.nextToken();
                                              String str= token.nextToken();
                      
                       boundaryString=str;                       
                       MimePartInputStream mimeInput=new MimePartInputStream(getInputStream(),boundaryString);
                       contentlist= mimeInput.readPart();
                       byte [] biIn= ((IAttachment)contentlist.get(0)).getAttachment();
                       ByteArrayInputStream binput= new ByteArrayInputStream(biIn);
                       content = MetasetParser.getInstance().parse(binput );
                      
                      break;
                   }
              }
              
          }
            return content;
        }
        protected ByteArrayOutputStream getContent(InputStream in
                 ) throws IOException {
            String cl = getHeader("Content-Length");
            int contentLength = 0;
                        ByteArrayOutputStream attachoutput = new ByteArrayOutputStream();
            
            if(cl==null){
                            	 int c =c= in.read();
              while(c!=-1){
                 
                                	  
                  attachoutput.write(c);
                  c= in.read();
              }
              return attachoutput;
            }
                       
            contentLength = Integer.parseInt(cl);
                        
            byte[] buf = new byte[2048];
            long t1 = System.currentTimeMillis();
            if (contentLength < 2048) {
                in.read(buf, 0, contentLength);
                attachoutput.write(buf, 0, contentLength);
            } else {
                int count = 0;
                int i = 0;
                while (true) {
                    int rest = contentLength - count;
                    if (rest > 2048) {
                        i = in.read(buf);
                        attachoutput.write(buf, 0, i);
                    } else {
                        i = in.read(buf, 0, rest);
                        attachoutput.write(buf, 0, i);
                        break;                    }
                    count = count + i;
                }
            }
            long t2 = System.currentTimeMillis();
          if(Application.isDebug()){
            System.out.println("ͨѶ׶αĴʱ Process time:" + (t2 - t1));
                                                            System.out
                    .println("AttachmentImpl.getContent()" + contentLength);
          }
            return attachoutput;
        }
        public IAttachment[] getAttachments() throws IOException {
                                                            if(content==null){
               content= getContent();
                
            }
            IAttachment []attachment;
            if(contentlist.size()<=1){
            attachment = new AttachmentImpl[0];     
            }else{
            attachment = new AttachmentImpl[contentlist.size()-1];
            }
            for (int i = 1; i < contentlist.size(); i++) {
                attachment[i-1]=(IAttachment)contentlist.get(i);
            }
            return attachment;
        }
    }
    public static class HTTPResponseContext implements ResponseTransportContext {
        private HttpServletResponse httpServletResponse = null;
 
        private Metaset content=null;
        
        private IAttachment cont=null;
        private IAttachment[] attachments=null;
                private Socket socket = null;
        
        public Socket getSocket() {
            return socket;
        }
        
        public void setSocket(Socket socket) {
            this.socket = socket;
        }
        
        public HTTPResponseContext(HttpServletResponse httpServletResponse) {
            this.httpServletResponse = httpServletResponse;
        }
        
        public HttpServletResponse getHttpServletResponse() {
            return httpServletResponse;
        }
        
        public void setHttpServletResponse(
                HttpServletResponse httpServletResponse) {
            this.httpServletResponse = httpServletResponse;
        }
        
        public OutputStream getOutputStream() throws IOException {
            return httpServletResponse.getOutputStream();
        }
        public ThreadPoolRunnable getResponseHandler() {
                        return new HTTPResponseProcessor(this);
        }
        
        public void setContent(Metaset response)  {
            
            this.content = response;
                        String prix = response.getNamespace();
            Metaset set = response.filter(".\\Header");
            if (set!=null) {
            	for (Iterator iter = set.getChilds().iterator(); iter.hasNext();) {
					Metaset element = (Metaset) iter.next();
					element.setNamespace(prix);
									}
            }
            cont=new ContentImpl(response); 
        }
        
        private void travese(Metaset element, String prix) {
			element.setNamespace(prix);
			for (Iterator iter = element.getChilds().iterator(); iter.hasNext();) {
				Metaset ele = (Metaset) iter.next();
				travese(ele, prix);
			}
		}
		
        public IAttachment getContent(){           
            return  cont;
        }
        
        public void setContent(IAttachment cont){
            this.cont=cont;
        }
       
        
        public void setAttachments(IAttachment[] attachments) {
            this.attachments = attachments;
        }
        
        
        public IAttachment[] getAttachments() {
            return attachments;
        }
    }
}
