
package org.act.services.protocol.http;
import java.io.FilterOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import org.act.services.IAttachment;

public class MimePartOutputStream extends FilterOutputStream {
    
    private static final byte CRLF[] = new byte[] { (byte) 13, (byte) 10 };
    
    private static final byte ENDCHUNK[] = CRLF;
        
    private boolean closed = false;
    
    private OutputStream outstream = null;
    private String separator = null;
    
    public MimePartOutputStream(OutputStream out, String separator) {
        super(out);
        if (out == null) {
            throw new NullPointerException("stream parameter is null");
        }
        this.outstream = out;
        this.separator = separator;
    }
    public void writePart(IAttachment attach) throws IOException {
        outstream.write(("--" + separator + "\r\n").getBytes());
        outstream.write(("Content-Type: " + attach.getContentType() + "\r\n")
                .getBytes());
        outstream.write("\r\n".getBytes());
        outstream.write(attach.getAttachment());
        outstream.write("\r\n".getBytes());
    }
    public static int getPartOutPutLength(IAttachment attach, String separ) {
        String s = "--" + separ + "\r\n" 
        + "Content-Type: "+ attach.getContentType() + "\r\n"
        + "\r\n" 
        + "\r\n";
        int i = s.getBytes().length + attach.getAttachment().length;
        return i;
    }
    public static int getCloseTagLength(String separ){
        return (separ+"----").getBytes().length;
    }
    public void writeCloseTag() throws IOException {
        outstream.write(("--" + separator + "--").getBytes());
    }
    
    public void flush() throws IOException {
        outstream.flush();
    }
    
    public void close() throws IOException {
        super.close();
    }
}
