
package org.act.services.workflow.context;
import java.util.ArrayList;
import java.util.List;

public class WorkflowRuntimeContextPoolImpl implements
		IWorkflowRuntimeContextPool {
	private List instances = new ArrayList();
	
	public WorkflowRuntimeContextPoolImpl() {
		super();
			}
	public int size() {
		return instances.size();
	}
	public Object get(int index) {
		synchronized (instances) {
			return instances.get(index);
		}
	}
	public WorkflowRuntimeContext[] getAll() {
		synchronized (instances) {
			return (WorkflowRuntimeContext[]) instances
					.toArray(new WorkflowRuntimeContext[0]);
		}
	}
	public void add(WorkflowRuntimeContext rc) {
		synchronized (instances) {
			instances.add(rc);
		}
	}
	public void remove(WorkflowRuntimeContext rc) {
		synchronized (instances) {
			instances.remove(rc);
		}
	}
}
