
package org.act.services.workflow.management;
import java.util.Vector;
import org.act.services.transaction.information.RunningData;
import org.act.services.transaction.manager.InferiorResource;
import org.act.services.transaction.participant.InferiorContext;
import org.act.services.workflow.transaction.TransactionInfoManager;

public class TransactionInfo {
	
	public static String getTxIdList()
	{
		Vector txLists=RunningData.getTxIdList();
		String txIdList="";
		
		for (int i=0;i<txLists.size();i++)
			txIdList=txIdList+(String)txLists.get(i)+"#";
		return txIdList;
	}
	
	
	public static String getTxStatus(String txId)
	{
		return RunningData.getTxStatus(txId);
	}
	
	
    public static int getRunningTxNumber()
    {
        return RunningData.getRunningTxNumber();
    }
    
    
    public static String getInferiorList(String txId)
	{
    	Vector inferiorLists=RunningData.getInferiorList(txId);
    	String inferiorList="";
    	for (int i=0;i<inferiorLists.size();i++)
    		inferiorList=inferiorList+(String)inferiorLists.get(i)+"#";
    	return inferiorList;
	}
    
    
    private static InferiorContext getInferiorContext(String txID,String servicename)
    {
    	return RunningData.getInferiorContext(txID,servicename);
    }
    
    
    
    public static String getInferiorInfo(String txID,String servicename)
    {
    	String result="";
    	InferiorContext ic=getInferiorContext(txID,servicename);
    	result=ic.getInferiorAddress()+"#"+ic.getStartTime()+"#"+ic.getStopTime()+"#"+ic.getStatus()+"#";
    	return result;
	}
    
        public static String getDeciderList()
    {
    	Vector Txids=TransactionInfoManager.GetTxids();
    	String txids="";
    	for(int i=0;i<Txids.size();i++)
    	{
    		txids=txids+(String)Txids.get(i)+"#";
    	}
    	return txids;
    }
    
    public static String getTransactionInfo(String txID) {
		String txInfo = "";
		TransactionInfoManager txm = new TransactionInfoManager();
		
		txInfo = txm.GetBeginTime(txID) + "#" + txm.GetConfirmTime(txID)+ "#"
				+ txm.GetPreparedTime(txID) + "#"+ txm.GetEndTime(txID)+ "#"
				+ txm.GetTXStatus(txID)+ "#"+txm.GetInstanceId(txID)+"#";
		Vector InferiorList=null;
		InferiorList=txm.GetInferiorList(txID);
		for(int i=0;i<InferiorList.size();i++)
		{
			String inferiorInfo="";
			InferiorResource ir=(InferiorResource)InferiorList.get(i);
			inferiorInfo=inferiorInfo+"~"+ir.getSatus()+"~"+ir.getInferiorId()
			+"~"+ir.getInfeirorAddress()
			+"~"+ir.getCanceltime_b()+"~"+ir.getCanceltime_e()
			+"~"+ir.getConfirmtime_b()+"~"+ir.getConfirmtime_e()
			+"~"+ir.getPreparetime_b()+"~"+ir.getPreparetime_e()+"~";
		}
		txInfo = txInfo + "#" ;
		return txInfo;
    	
    }
    
    public static String getTxStatisticInfo()
    {
    	String txStaInfo="";
    	TransactionInfoManager txm = new TransactionInfoManager();
    	txStaInfo = txm.GetAvgConfirmTime() + "#" + txm.GetAvgPrepareTime()+ "#"
		+ txm.GetConfirmTxNum()+ "#"+ txm.GetCancelTxNum()+ "#"
		+ txm.GetTimeOutTxNum()+ "#";
    	return txStaInfo;
    }
    
    public static int getConfirmTxNum()
    {
    	TransactionInfoManager txm = new TransactionInfoManager();
    	return txm.GetConfirmTxNum();
    }
    
    public static int getCancelTxNum()
    {
    	TransactionInfoManager txm = new TransactionInfoManager();
    	return txm.GetCancelTxNum();
    }
    
    public static int getTimeOutTxNum()
    {
    	TransactionInfoManager txm = new TransactionInfoManager();
    	return txm.GetTimeOutTxNum();
    }
        
}
