
package org.act.services.workflow.management;
import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import org.act.services.workflow.context.WorkflowContext;
import org.act.services.workflow.context.WorkflowContextPoolImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.workflow.context.WorkflowRuntimeContextPoolImpl;
import org.act.services.workflow.record.WorkflowActivityRecord;
import org.act.services.workflow.transaction.TransactionInfoManager;
import org.act.services.workflow.deploy.DeployManager;

public class WFInfo {
	public static final char NL = '\n';
	public static final char CR = '\r';
	
	public static final String LS = System.getProperty("line.separator",
			(new Character(NL)).toString());
	
	public static String getDeployedInstances() {
		WorkflowContext[] wfContext = WorkflowContextPoolImpl.INSTANCE
				.getWorkflowContext();
		String instanceList = "#";
		for (int i = 0; i < wfContext.length; i++) {
			instanceList = instanceList + wfContext[i].getName() + "#";
		}
		return instanceList;
	}
	
	public static String DeployInstance(String type, String file) {
		return null;
			}
	
	public static String UnDeployInstance(String type) {
		String result = "";
		try {
			if (DeployManager.anti_deploy(type))
				result = "success";
			else
				result = "fail";
		} catch (Exception ex) {
			result = "error";
		}
		return result;
			}
	
	public static String invokeInstance(String type, String invokeInfo) {
		return null;
			}
	
	public static String getBpel(String type) {
		String dir = System.getProperty(DeployManager.WORKING_DIR)
				+ java.io.File.separator + type + ".bar"
				+ java.io.File.separator + "META-INF" + java.io.File.separator
				+ type + ".bpel";
		String fileContent = "";
		try {
			File wsdlFile = new File(dir);
						DataInputStream input = new DataInputStream(
					new BufferedInputStream(new FileInputStream(wsdlFile)));
			ByteArrayOutputStream outputstrem = new ByteArrayOutputStream();
			int nNumber = 0;
			byte[] buffer = new byte[4096];
			while ((nNumber = input.read(buffer)) != -1) {
				outputstrem.write(buffer, 0, nNumber);
			}
			input.close();
			fileContent = new String(outputstrem.toByteArray());
			outputstrem.close();
		} catch (FileNotFoundException e) {
			System.err.print(type + "bpelļδҵ");
		} catch (IOException e) {
			System.err.println("ļ");
		}
				return fileContent.trim();
	}
	
	public static String getWFWsdd(String type) {
		String dir = System.getProperty(DeployManager.WORKING_DIR)
				+ java.io.File.separator + type + ".bar"
				+ java.io.File.separator + "META-INF" + java.io.File.separator
				+ "service.xml";
		String fileContent = "";
		try {
			File wsdlFile = new File(dir);
						DataInputStream input = new DataInputStream(
					new BufferedInputStream(new FileInputStream(wsdlFile)));
			ByteArrayOutputStream outputstrem = new ByteArrayOutputStream();
			int nNumber = 0;
			byte[] buffer = new byte[4096];
			while ((nNumber = input.read(buffer)) != -1) {
				outputstrem.write(buffer, 0, nNumber);
			}
			input.close();
			fileContent = new String(outputstrem.toByteArray());
		} catch (FileNotFoundException e) {
			System.err.print(type + "wsddļδҵ");
		} catch (IOException e) {
			System.err.println("ļ");
		}
		return normalize(fileContent.trim());
	}
	
	public static String getActiveInstance(String type) {
		WorkflowRuntimeContext[] wfRuntimeContexts = WorkflowRuntimeContextPoolImpl.INSTANCE
				.getAll();
		String InstanceList = "#";
				for (int i = 0; i < wfRuntimeContexts.length; i++) {
			WorkflowRuntimeContext wrc = (WorkflowRuntimeContext) wfRuntimeContexts[i];
						if (wrc.getAgent() != null) {
				for (int j = 0; j < wrc.getActivityRecords().size(); j++) {
					WorkflowActivityRecord war = (WorkflowActivityRecord) (wrc
							.getActivityRecords().get(j));
					String txidNow = war.getTransactionId();
					String instanceidNow = wrc.getWir().getInstanceID();
					if (instanceidNow != null && txidNow != null) {
						(new TransactionInfoManager()).SetInstanceId(war
								.getTransactionId(), wrc.getWir()
								.getInstanceID());
						System.err.println(war.getTransactionId() + "::::::"
								+ wrc.getWir().getInstanceID());
					}
				}
			}
			if (wrc.getWir().getType() != null
					&& wrc.getWir().getType().equalsIgnoreCase(type)) {
				InstanceList = InstanceList + wrc.getWir().getType() + "~";
				InstanceList = InstanceList + wrc.getWir().getInstanceID()
						+ "~";
				InstanceList = InstanceList + wrc.getWir().getBeginTime() + "~";
				InstanceList = InstanceList + wrc.getWir().getStatus() + "~";
				for (int j = 0; j < wrc.getActivityRecords().size(); j++) {
					WorkflowActivityRecord war = (WorkflowActivityRecord) (wrc
							.getActivityRecords().get(j));
					InstanceList = InstanceList + war.getName() + "`";
					InstanceList = InstanceList + war.getType() + "`";
					InstanceList = InstanceList + war.getBeginTime() + "`";
					if (null == war.getFinishTime())
						InstanceList = InstanceList + war.getFinishTime() + "`";
					else
						InstanceList = InstanceList + war.getFinishTime() + "`";
					InstanceList = InstanceList + war.getStatus() + "`";
										if (null == war.getTransactionId())
						InstanceList = InstanceList + war.getTransactionId()
								+ "`";
					else {
						InstanceList = InstanceList + war.getTransactionId()
								+ "`";
					}
				}
				InstanceList = InstanceList + "~";
				InstanceList = InstanceList + "#";
			}
		}
		return InstanceList;
	}
	
	public static String getActivity(String instanceID) {
		String activityList = "";
		WorkflowRuntimeContext[] wfRuntimeContexts = WorkflowRuntimeContextPoolImpl.INSTANCE
				.getAll();
		for (int i = 0; i < wfRuntimeContexts.length; i++) {
			WorkflowRuntimeContext wrc = (WorkflowRuntimeContext) wfRuntimeContexts[i];
			if (wrc.getWir().getInstanceID().equalsIgnoreCase(instanceID)) {
				for (int j = 0; j < wrc.getActivityRecords().size(); j++) {
					WorkflowActivityRecord war = (WorkflowActivityRecord) (wrc
							.getActivityRecords().get(j));
					activityList = activityList + war.getName() + "`";
					activityList = activityList + war.getType() + "`";
					activityList = activityList + war.getBeginTime() + "`";
					if (null == war.getFinishTime())
						activityList = activityList + war.getFinishTime() + "`";
					else
						activityList = activityList + war.getFinishTime() + "`";
					activityList = activityList + war.getStatus() + "`";
					if (null == war.getTransactionId())
						activityList = activityList + war.getTransactionId()
								+ "`";
					else
						activityList = activityList + war.getTransactionId()
								+ "`";
									}
			}
		}
		return activityList;
	}
	
	private static String normalize(String s) {
		StringBuffer str = new StringBuffer();
		int len = (s != null) ? s.length() : 0;
		for (int i = 0; i < len; i++) {
			char ch = s.charAt(i);
			switch (ch) {
			case '<': {
				str.append("&lt;");
				break;
			}
			case '>': {
				str.append("&gt;");
				break;
			}
			case '&': {
				str.append("&amp;");
				break;
			}
			case '"': {
				str.append("&quot;");
				break;
			}
			case NL: {
				if (i > 0) {
					char lastChar = str.charAt(str.length() - 1);
					if (lastChar != CR) {
						str.append(LS);
					} else {
						str.append(NL);
					}
				} else {
					str.append(LS);
				}
				break;
			}
			default: {
				str.append(ch);
			}
			}
		}
		return (str.toString());
	} }
