package org.act.services.workflow.record;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;
import java.util.List;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.workflow.debug.Debug;

public class Records2DB {
	
	private static Connection conn;
	private static PreparedStatement statement;
	
	public Records2DB() {
		super();
			}
		public static boolean useDB() {
		if (!Debug.isDebug() && System.getProperty("UseDB").equals("true")) {
			return true;
		}
		return false;
	}
		public static synchronized void engine2DB() {
		if (useDB()) {
			connection();
			String startTime = (new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS"))
					.format(new GregorianCalendar().getTime());
			try {
				statement = conn
						.prepareStatement("insert into bpelengine (startTime) values(?)");
				statement.setString(1, startTime);
				statement.execute();
				statement.close();
			} catch (SQLException e) {
								e.printStackTrace();
			}
			disconnection();
		}
	}
		public static synchronized void instance2DB(WorkflowRuntimeContext rc) {
		if (useDB()) {
			connection();
			try {
				instanceRecord2DB(rc);
				activityRecord2DB(rc.getActivityRecords(), rc.getInstanceID());
			} catch (SQLException e) {
								e.printStackTrace();
			}
			disconnection();
		}
	}
		private static void instanceRecord2DB(WorkflowRuntimeContext rc)
			throws SQLException {
		WorkflowInstanceRecord wir = rc.getWir();
		if (!wir.isInDB()) {
			statement = conn
					.prepareStatement("insert into bpelinstance (InstanceID,Type,BeginTime,FinishTime,Status) values(?,?,?,?,?)");
			statement.setString(1, wir.getInstanceID());
			statement.setString(2, wir.getType());
			statement.setString(3, wir.getBeginTime());
			statement.setString(4, wir.getFinishTime());
			statement.setString(5, wir.getStatus());
			statement.execute();
			statement.close();
			wir.setInDB(true);
		} else {
			statement = conn
					.prepareStatement("update bpelinstance set FinishTime=?,Status=? where InstanceID=?");
			statement.setString(1, wir.getFinishTime());
			statement.setString(2, wir.getStatus());
			statement.setString(3, wir.getInstanceID());
			statement.execute();
			statement.close();
		}
	}
		private static void activityRecord2DB(List activityRecords,
			String InstanceID) throws SQLException {
		for (int j = 0; j < activityRecords.size(); j++) {
			WorkflowActivityRecord war = (WorkflowActivityRecord) activityRecords
					.get(j);
			if (!war.isInDB()) {
				statement = conn
						.prepareStatement("insert into bpelactivity (InstanceID,Name,Type,BeginTime,FinishTime,Status,TransactionID) values(?,?,?,?,?,?,?)");
				statement.setString(1, InstanceID);
				statement.setString(2, war.getName());
				statement.setString(3, war.getType());
				statement.setString(4, war.getBeginTime());
				statement.setString(5, war.getFinishTime());
				statement.setString(6, war.getStatus());
				statement.setString(7, war.getTransactionId());
				statement.execute();
				statement.close();
				war.setInDB(true);
			} else {
				statement = conn
						.prepareStatement("update bpelactivity set FinishTime=?,Status=? where InstanceID=? and Name=?");
				statement.setString(1, war.getFinishTime());
				statement.setString(2, war.getStatus());
				statement.setString(3, InstanceID);
				statement.setString(4, war.getName());
				statement.execute();
				statement.close();
			}
			if (war.getStatus().equals("completed")) {
				activityRecords.remove(war);
				j--;
			}
		}
	}
		private static void connection() {
		try {
			Class.forName(System.getProperty("Driver"));
		} catch (ClassNotFoundException e) {
						e.printStackTrace();
		}
		String url = System.getProperty("DBaddress");
		String user = System.getProperty("DBUser");
		String password = System.getProperty("DBPWD");
		try {
			conn = DriverManager.getConnection(url, user, password);
		} catch (SQLException e1) {
						e1.printStackTrace();
		}
	}
	
		private static void disconnection() {
		try {
			conn.close();
		} catch (SQLException e) {
						e.printStackTrace();
		}
	}
}
